/**
 * Created by marszed on 16/7/11.
 */


'use strict';

define(["url"], function (url) {
    /*路由处理*/
    var oldURL, newURL;

    window.addEventListener('hashchange', function (hash) {
        oldURL = hash.oldURL;
        newURL = hash.newURL;
    });

    /**
     * [pop Native调用pop能返回到前一个hash值页面]
     * @return {[undefined]} [undefined]
     */
    window.pop = function () {
        var old = url.parse(oldURL);
        router.navigate(old.hash.length ? old.hash : '#discovery', {trigger: true});
    };


    /*与原始交互*/
    var ua = navigator.userAgent;

    var application = {
        win: /android/i.test(ua) ? window.jsApi : window,//h5调用原生的方式 andriod ios
        isIOS: /iphone|ipad|ipod/i.test(ua),//是ios机型
        isAndroid: /android/i.test(ua),//是andriod机型
        onLine: /android/i.test(ua) ? window.jsApi.onLine() : window.navigator.onLine//是否联网
    };

    /**
     * [checkNetStatus web调用Native获取网络状态]
     * @return {[undefined]} [undefined]
     * Unknown          = -1,//网络还未开始检测
     * NotReachable     = 0,//无网络连接
     * ReachableViaWWAN = 1,//使用GPRS或者3G网络连接
     *ReachableViaWiFi = 2,//wifi
     */

    return application;
});