
'use strict';

define([''], function() {
    var dpr, rem, scale = 1;
    var docEl = document.documentElement;
    var docWidth = docEl.clientWidth;
    var initialize = function() {
        var docEl = document.documentElement;
        var fontEl = document.createElement('style');
        var metaEl = document.querySelector('meta[name="viewport"]');
        dpr = window.devicePixelRatio || 1;
        rem = docEl.clientWidth * dpr / 10;
        scale = 1 / dpr;

        metaEl.setAttribute('content', 'width=' + 2 * docEl.clientWidth + ',initial-scale=' +   0.5 + ',maximum-scale=' + 0.5 + ', minimum-scale=' + 0.5 + ',user-scalable=no');

        docEl.setAttribute('data-dpr', dpr);
        docEl.firstElementChild.appendChild(fontEl);
        fontEl.innerHTML = 'html{font-size:' + rem + 'px!important;}';

        window.dpr = dpr;
        window.clientWidth = docEl.clientWidth;
        window.rem = rem;
    };
    return{
    	//初始化
        init: initialize,
        /**
         * [px2rem description]
         * @param  {[type]} v [description]
         * @return {[type]}   [description]
         */
        px2rem: function(v) {
            dpr = window.devicePixelRatio || 1;
            rem = docWidth * dpr / 10;
            return parseFloat(v) / rem;
        },
        /**
         * [rem2px description]
         * @param  {[type]} v [description]
         * @return {[type]}   [description]
         */
        rem2px: function(v) {
            dpr = window.devicePixelRatio || 1;
            rem = docWidth * dpr / 10;
            return parseFloat(v) * rem;
        }
    };
});
