// Activity Index View
define(['views/baseView', 'rem', 'application'], function(BaseView, Rem, Application) {

  var activityView = BaseView.extend({
    events: {
      "click .topGoods_item" : "onTapSpecials",
      "click .listGoods_item": "onTapSpecials"
    },

    initialize: function(opt) {
      this.fastClick();
      this.$el = $('#activity');
    },

    render: function(activityId, data) {
      $("html").css("background","#f8f1df");
      if(data['activity_color_'+activityId]){
        var color = data['activity_color_'+activityId][0];
        $("html").css("background",color.background_color);
      }

      Application.win.setTitleBar(JSON.stringify({
        title:'特卖优惠',
        titleBarBg:"",
        titleTextColor:""
      }));
      
      var banner = data['activity_banner_' + activityId];
      if(banner[0].imgUrl.indexOf('@') == -1) {
          banner[0].imgUrl = banner[0].imgUrl + "@" + window.clientWidth + "w";
      }
      // 渲染头图
      var banner_tpl = $("#activity_banner_tpl").html();
      this.$el.find(".banner-wrapper").html(this.getHtml(banner_tpl, {data: banner[0]}));

      $(".banner-wrappers img").on("load",function(){
        $(".banner-wrappers").height($(".banner-wrappers img").height())
      });
      
      // 渲染爆款商品
      var goods = data["activity_goods_" + activityId];
      var topGoods = $.map(goods, function (item, index) {
        if(item.typeSort == 1 ) {
          return item;
        }
      });
      $.each(topGoods, function(idx, item) {
         $.each(item.data,function(i,v){
          if (v.imgUrl.indexOf('@') == -1) {
              v.imgUrl = v.imgUrl + "@" + $(".topGoods_item").width() + "w";
          }
         })
      });
      var activity_topGoods = $("#activity_topGoods_tpl").html();
      this.$el.find(".topGoods_wrapper").html(this.getHtml(activity_topGoods, {data: topGoods}));

      //渲染其他商品
      var listGoods = goods.slice(1);
      var activity_listGoods = $("#activity_listGoods_tpl").html();
      this.$el.find(".listGoods_wrapper").html(this.getHtml(activity_listGoods, {data: listGoods}));
      //变换各种颜色
      if(data['activity_color_'+activityId]){
        $(".activity_header span").css({"color":color.text_color,"background":color.navibar_color});
        var leftsanjiao = $('<style>.activity_header span:before{content:"";width:0;height:0;border-top:23px solid transparent;border-bottom:23px solid transparent;border-left:23px solid '+color.navibar_color+';position: absolute;left: 193px;top: -1px;}</style>').appendTo($(".activity_header span"));
        var reghtsanjiao = $('<style>.activity_header span:after{content:"";width:0;height:0;border-top:23px solid transparent;border-bottom:23px solid transparent;border-right:23px solid '+color.navibar_color+';position: absolute;left: -22px; top: -1px;}</style>').prependTo($(".activity_header span"));
        var leftxian = $('<style>.activity_header:after{content:"";width: 27%;height: 2px;background:'+color.navibar_color+';position: absolute;left: 0; top: 55%;}</style>').prependTo($(".activity_header"));
        var rightxian = $('<style>.activity_header:before{content:"";width: 27%;height: 2px;background:'+color.navibar_color+';position: absolute;right: 0; top: 55%;}</style>').prependTo($(".activity_header"));
      }
       
    },
    onTapSpecials: function(e) {
        var id = $(e.currentTarget).data("id"),
            surplus = $(e.currentTarget).data("count");
        Application.win.showGoodsDetail(JSON.stringify({
          id: id
        }));
    }
  });
  return activityView;
});
