// BaseView

'use strict';

define(['zepto', 'underscore', 'artTpl', 'backbone', 'swiper', 'fastclick', 'rem', 'text', 'application'],
    function($, _, Tpl, Backbone, Swiper, FastClick, Rem, Text, Application) {

        if (Application.isIOS) {
            var _sort = Array.prototype.sort;
            Array.prototype.sort = function(fn) {
                if (!!fn && typeof fn === 'function') {
                    if (this.length < 2) return this;
                    var i = 0,
                        j = i + 1,
                        l = this.length,
                        tmp, r = false,
                        t = 0;
                    for (; i < l; i++) {
                        for (j = i + 1; j < l; j++) {
                            t = fn.call(this, this[i], this[j]);
                            r = (typeof t === 'number' ? t : t ? 1 : 0) > 0 ? true : false;
                            if (r) {
                                tmp = this[i];
                                this[i] = this[j];
                                this[j] = tmp;
                            }
                        }
                    }
                    return this;
                } else {
                    return _sort.call(this);
                }
            };
        }


        var base = Backbone.View.extend({
            el: $('#container'),
            plugins: {
                "tplEng": Tpl,
                "Swiper": Swiper
                //"Bridge": Bridgex
            },
            getHtml: function(tplStr, data) {
                return this.plugins.tplEng.compile(tplStr)(data);
            },

            defaultLayout: {
                "discovery_swiper_height": 230,
                "discovery_service_height": 120,
                "discovery_catalog_height": 100,
                "discovery_shop_height": 196,
                "discovery_shopheader_height": 68,
                "discovery_event_height": 400
            },

            renderDiscoveryBase: function(callback) {
                var self = this;
                Text.get('./js/templates/discovery/discoveryIndexTpl.html', function(html) {
                    var data = {};
                    var compiledTemplate = _.template(html, data);
                    self.$el.html(compiledTemplate);
                    self.renderDiscoveryEl();
                    callback();
                });
            },
            renderActivityBase: function(callback) {
                var self = this;
                Text.get('./js/templates/activity/activityTpl.html', function(html) {
                    var data = {};
                    var compiledTemplate = _.template(html, data);
                    self.$el.html(compiledTemplate);
                    callback();
                });
            },
            renderGroupBuying:function(callback){
                var self = this;
                Text.get('./act/groupbuy.html', function(html) {
                    var data = {};
                    var compiledTemplate = _.template(html, data);
                    self.$el.html(compiledTemplate);
                    callback()
                });
            },
            renderDiscoveryEl: function() {
                //取消对推荐商品的样式控制,使其自适应
                $('.swiper-container').height(Rem.px2rem(this.defaultLayout.discovery_swiper_height) + 'rem');
                $('.swiper-box').height(Rem.px2rem(this.defaultLayout.discovery_swiper_height) + 'rem');
                $('.service-box').height(Rem.px2rem(this.defaultLayout.discovery_service_height) + 'rem');
                $('.catalog-box').height(Rem.px2rem(this.defaultLayout.discovery_catalog_height) + 'rem');
                //$('.event-box').height(Rem.px2rem(this.defaultLayout.discovery_event_height) + 'rem');
                //$('.event-box li.li-grid').height(Rem.px2rem(this.defaultLayout.discovery_event_height) / 2 + 'rem');
                $('.shop-box').height(Rem.px2rem(this.defaultLayout.discovery_shop_height) + 'rem');
                $('.shop-header-box').height(Rem.px2rem(this.defaultLayout.discovery_shopheader_height) + 'rem');
            },
            fastClick: function() {
                FastClick.attach(document.body);
            }
        });
        return base;

    });
