// Discovery Index View

'use strict';

define(['views/baseView', 'rem', 'application'], function(BaseView, Rem, Application) {
    var merchant_idx = [];
    var handlerSort = function(idx, merchant) {
        var level = idx.sort(function(x, y) {
            return Math.floor(x.level) < Math.floor(y.level);
        });
        level.forEach(function(v, i) {
            var tagName = v.tagName;
            var le = v.level;
            merchant.forEach(function(h) {
                if (h.name === tagName) {
                    h.level = le;
                }
            });
        });
        var fxMerchant = merchant.sort(function(x, y) {
            return Math.floor(x.level) < Math.floor(y.level);
        });
        return fxMerchant;
    };
    var handlerSorts = function(idx) {
        var _order = idx.sort(function(x, y) {
            return Math.floor(x._order) < Math.floor(y._order);
        });
        return _order;
    };
    var discoveryIndexView = BaseView.extend({
        events: {
            "click .service-box": "onTapService",
            "click .left": "onTapNewService",
            "click .right": "onTapNewService",
            "click .catalog-item": "onTapShopCataItem",
            "click .shop-box": "onTapShopItem",
            "click .commodityType":"onTapCommodityType",
            "click .commodityRightDetail":"onTapCommodityRight",
            "click .commodityLeftDetail":"onTapCommodityLeft"
        },
        initialize: function(opt) {
            this.fastClick();
            this.$el = $('#discovery');
        },
        render: function(data, merchant) {
            $("html").css("background", "#ffffff");
            var banners = data.faxian_banner;
            // 渲染轮播视图
            if(banners && banners.length){
                var tempBanners = _.clone(banners);
                $.each(banners, function(idx, item) {
                    if (item.imgUrl.indexOf('@') == -1) {
                        item.imgUrl = item.imgUrl + "@" + window.clientWidth + "w";
                    }
                });
                var orderdata = handlerSorts(banners);
                var swiper_tpl = $("#discovery_swiper_tpl").html();
                this.$el.find(".swiper-wrapper").html(this.getHtml(swiper_tpl, {
                    data: orderdata
                }));
            }
            
            //渲染服务入口
            var faxian_service = data.faxian_service;
            if(faxian_service&&faxian_service.length){
            	var $self=this;
            	var i;
            	$.each(faxian_service,function(index,serviceData){
            		if(serviceData.targetType){
            			/*if(serviceData.targetType=="周边商铺"){
            			 var service_kuaisong = $("#discovery_service_shangpu").html();
            			 $self.$el.find(".shangpu-wrapper").html($self.getHtml(service_kuaisong, {
                             data: data.faxian_service[index]
                         }));
            			}*/
            			if(serviceData.targetType=="电商宅配"){
            				 var service_kuaisong = $("#discovery_service_dianshang").html();
                			 $self.$el.find(".dianshang-wrapper").html($self.getHtml(service_kuaisong, {
                                 data: data.faxian_service[index]
                             }));
               			}
                        if(serviceData.targetType=="楼下店铺"){
                            var service_kuaisong = $("#discovery_service_louxia").html();
                            $self.$el.find(".louxia-wrapper").html($self.getHtml(service_kuaisong, {
                                data: data.faxian_service[index]
                            }));
                        }
                        /*if(serviceData.targetType=="社区快送"){
                            var service_kuaisong = $("#discovery_service_kuaisong").html();
                            $self.$el.find(".kuaisong-wrapper").html($self.getHtml(service_kuaisong, {
                                data: data.faxian_service[index]
                            }));
                        }*/
            		}
            		
            	});
            }else{
            	 $(".grid").hide();
            }


            // 渲染推荐商品位视图
            // var eventbox_height = $('.event-box li').height();
            // console.log(data.faxian_goods);
            // var event_left_tpl = $("#discovery_event_left_tpl").html();
            // var event_left_good = data.faxian_goods[0];
            // if(event_left_good.imgUrl.indexOf('@') == -1) {
            //   event_left_good.imgUrl = event_left_good.imgUrl + "@" + parseInt($('.event-box li').width()) + "w" + "_" + parseInt(eventbox_height) + "h";
            // }
            // this.$el.find(".event-left-wrapper").html(this.getHtml(event_left_tpl, {data: event_left_good}));
            // $('.event-box li.li-grid').height(eventbox_height);


            // var event_right_good = data.faxian_goods.slice(1);
            // if(event_right_good.length) {
            //   var event_right_tpl = $("#discovery_event_right_tpl").html();
            //   $.each(event_right_good, function(idx, item) {
            //     if(item.imgUrl.indexOf('@') == -1) {
            //       item.imgUrl = item.imgUrl + "@" + parseInt($('.event-box li').width()) + "w" + "_" + parseInt(eventbox_height) + "h";
            //     }
            //   });
            //   this.$el.find(".event-right-wrapper").html(this.getHtml(event_right_tpl, {data: event_right_good}));
            //   $('.event-box li.li-grid').height(eventbox_height);

            // } else {
            //   var event_right_good_v1 = $('#discovery_event_v1_right_tpl').html();
            //   $.each(data.faxian_event, function(idx, item) {
            //     if(item.imgUrl.indexOf('@') == -1) {
            //       item.imgUrl = item.imgUrl + "@" + parseInt($('.event-box li').width()) + "w" + "_" + parseInt(eventbox_height) + "h";
            //     }
            //   });
            //   this.$el.find(".event-right-wrapper").html(this.getHtml(event_right_good_v1, {data: data.faxian_event}));
            //   $('.event-box li.li-grid').height(eventbox_height);
            // }




            var eventbox_height = $('.event-box li').height();
            if(data.faxian_event_v2&&data.faxian_event_v2.length){
                var event_left_data = data.faxian_event_v2[0];
                var event_right_data = data.faxian_event_v2.slice(1);
                var discovery_faxian_event_tpl = $('#discovery_faxian_event_right_tpl').html();
                var discovery_faxian_event_left = $('#discovery_faxian_event_left_tpl').html();

                //暂不做推荐商品图片处理
                //if (event_left_data.imgUrl.indexOf('@') == -1) {
                //    event_left_data.imgUrl = event_left_data.imgUrl + "@" + parseInt($('.event-box li').width()) + "w" + "_" + parseInt(eventbox_height) + "h";
                //}
				//
                //$.each(event_right_data, function(idx, item) {
                //    if (item.imgUrl.indexOf('@') == -1) {
                //        item.imgUrl = item.imgUrl + "@" + parseInt($('.event-box li').width()) + "w" + "_" + parseInt(eventbox_height) + "h";
                //    };
                //});
                this.$el.find(".event-left-wrapper").html(this.getHtml(discovery_faxian_event_left, {
                    data: event_left_data
                }));
                $('.event-box li.li-grid').height(eventbox_height);
                this.$el.find(".event-right-wrapper").html(this.getHtml(discovery_faxian_event_tpl, {
                    data: event_right_data
                }));
                $('.event-box li.li-grid').height(eventbox_height);
            }
            
            // 渲染商铺分类视图
            // var catalog_tpl = $("#discovery_catalog_tpl").html();
            // this.$el.find(".catalog-wrapper").html(this.getHtml(catalog_tpl, {
            //     data: data.faxian_class
            // }));
            var box_height, header_height, merchant_tpl;
            
            // 渲染商铺列表
            if (merchant) {
                header_height = ($('.shop-header-box').height());
                merchant_tpl = $("#discovery_merchant_v1_tpl").html();
                merchant_idx.length = 0;
                if(data.faxian_merchant&&data.faxian_merchant.length){    
                    var m = data.faxian_merchant,
                        i = 0,
                        len = m.length,
                        y = -1,
                        dataHash = {};
                    for (; i < len; i++) {
                        var item = m[i];
                        if(dataHash[item.className]) {
                            dataHash[item.className].data.push(item);
                        } else {
                            dataHash[item.className] = {
                                className: item.className, 
                                data:[item]
                            };
                        }
                    }
                    for(var type in dataHash) {
                        if(dataHash.hasOwnProperty(type)) {
                            merchant_idx.push(dataHash[type]);
                        }
                    }

                    this.$el.find(".merchant_wrapper").html(this.getHtml(merchant_tpl, {
                        data: merchant_idx
                    }));

                    $('.shop-header-box').height(header_height);
                }
                
            } else {
                if(data.faxian_merchant&&data.faxian_merchant.length){
                    var fxMerchant = handlerSort(data.faxian_merchant_idx, data.faxian_merchant);
                    header_height = $('.shop-header-box').height();
                    // merchant_tpl = $("#discovery_merchant_tpl").html();
                    // this.$el.find(".merchant_wrapper").html(this.getHtml(merchant_tpl, {
                    //     data: fxMerchant
                    // }));
                    $('.shop-header-box').height(header_height);
                }
            }


            // 渲染商品列表
            var commodityTitle_1 = $("#commodityTitle_1"),
                commodityTitleTpl_1 = $("#commodityTitleTpl_1").html(),
                itemLeft_1 = $("#itemLeft_1"),
                itemLeftTpl_1 = $("#itemLeftTpl_1").html(),
                itemRight_1 = $("#itemRight_1"),
                itemRightTpl_1 = $("#itemRightTpl_1").html(),
                goodsType_left_1 = {},
                goodsType_right_1 = {};


                if(data.faxian_goodsType_1){
                    goodsType_left_1 = data.faxian_goodsType_1[0];
                    goodsType_right_1 = data.faxian_goodsType_1.slice(1);

                    this.$el.find("#commodityTitle_1").html(this.getHtml(commodityTitleTpl_1, {
                        data:goodsType_left_1
                    }));
                    this.$el.find("#itemLeft_1").html(this.getHtml(itemLeftTpl_1, {
                        data:goodsType_left_1
                    }));
                    this.$el.find("#itemRight_1").html(this.getHtml(itemRightTpl_1, {
                        data:goodsType_right_1
                    }));
                }else{
                    $(".commodity_list1").hide();
                    console.log("commodity_list1隐藏")
                }
            

            var commodityTitle_2 = $("#commodityTitle_2"),
                commodityTitleTpl_2 = $("#commodityTitleTpl_2").html(),
                itemLeft_2 = $("#itemLeft_2"),
                itemLeftTpl_2 = $("#itemLeftTpl_2").html(),
                itemRight_2 = $("#itemRight_2"),
                itemRightTpl_2 = $("#itemRightTpl_2").html(),
                goodsType_left_2 = {},
                goodsType_right_2 = {};
                
                if(data.faxian_goodsType_2){
                    goodsType_left_2 = data.faxian_goodsType_2[0];
                    goodsType_right_2 = data.faxian_goodsType_2.slice(1);

                    this.$el.find("#commodityTitle_2").html(this.getHtml(commodityTitleTpl_2, {
                        data:goodsType_left_2
                    }));
                    this.$el.find("#itemLeft_2").html(this.getHtml(itemLeftTpl_2, {
                        data:goodsType_left_2
                    }));
                    this.$el.find("#itemRight_2").html(this.getHtml(itemRightTpl_2, {
                        data:goodsType_right_2
                    }));
                }else{
                    $(".commodity_list2").hide();
                    console.log("commodity_list2隐藏");
                }
            

            var commodityTitle_3 = $("#commodityTitle_3"),
                commodityTitleTpl_3 = $("#commodityTitleTpl_3").html(),
                itemLeft_3 = $("#itemLeft_3"),
                itemLeftTpl_3 = $("#itemLeftTpl_3").html(),
                itemRight_3 = $("#itemRight_3"),
                itemRightTpl_3 = $("#itemRightTpl_3").html(),
                goodsType_left_3 = {},
                goodsType_right_3 = {};
                if(data.faxian_goodsType_3){
                    goodsType_left_3 = data.faxian_goodsType_3[0];
                    goodsType_right_3 = data.faxian_goodsType_3.slice(1);

                    this.$el.find("#commodityTitle_3").html(this.getHtml(commodityTitleTpl_3, {
                        data:goodsType_left_3
                    }));
                    this.$el.find("#itemLeft_3").html(this.getHtml(itemLeftTpl_3, {
                        data:goodsType_left_3
                    }));
                    this.$el.find("#itemRight_3").html(this.getHtml(itemRightTpl_3, {
                        data:goodsType_right_3
                    }));
                }else{
                    $(".commodity_list3").hide();
                    console.log("commodity_list3隐藏");
                }
                
            

            var commodityTitle_4 = $("#commodityTitle_4"),
                commodityTitleTpl_4 = $("#commodityTitleTpl_4").html(),
                itemLeft_4 = $("#itemLeft_4"),
                itemLeftTpl_4 = $("#itemLeftTpl_4").html(),
                itemRight_4 = $("#itemRight_4"),
                itemRightTpl_4 = $("#itemRightTpl_4").html(),
                goodsType_left_4 = {},
                goodsType_right_4 = {};
                if(data.faxian_goodsType_4){
                    goodsType_left_4 = data.faxian_goodsType_4[0],
                    goodsType_right_4 = data.faxian_goodsType_4.slice(1);

                    this.$el.find("#commodityTitle_4").html(this.getHtml(commodityTitleTpl_4, {
                        data:goodsType_left_4
                    }));
                    this.$el.find("#itemLeft_4").html(this.getHtml(itemLeftTpl_4, {
                        data:goodsType_left_4
                    }));
                    this.$el.find("#itemRight_4").html(this.getHtml(itemRightTpl_4, {
                        data:goodsType_right_4
                    }));
                }else{
                    $(".commodity_list4").hide();
                    console.log("commodity_list4隐藏");
                }

            var commodityTitle_5 = $("#commodityTitle_5"),
                commodityTitleTpl_5 = $("#commodityTitleTpl_5").html(),
                itemLeft_5 = $("#itemLeft_5"),
                itemLeftTpl_5 = $("#itemLeftTpl_5").html(),
                itemRight_5 = $("#itemRight_5"),
                itemRightTpl_5 = $("#itemRightTpl_5").html(),
                goodsType_left_5 = {},
                goodsType_right_5 = {};
            if(data.faxian_goodsType_5){
                goodsType_left_5 = data.faxian_goodsType_5[0],
                goodsType_right_5 = data.faxian_goodsType_5.slice(1);

                this.$el.find("#commodityTitle_5").html(this.getHtml(commodityTitleTpl_5, {
                    data:goodsType_left_5
                }));
                this.$el.find("#itemLeft_5").html(this.getHtml(itemLeftTpl_5, {
                    data:goodsType_left_5
                }));
                this.$el.find("#itemRight_5").html(this.getHtml(itemRightTpl_5, {
                    data:goodsType_right_5
                }));
            }else{
                $(".commodity_list4").css({"padding-bottom": '100px'});
                $(".commodity_list5").hide();
                console.log("commodity_list5隐藏")
            }



            if (Application.isAndroid) {
                $('.merchant_wrapper').addClass('foot_wrapper');
            }
            var Swiper = this.plugins.Swiper;
            var self = this;
            this.swiper = new Swiper('.swiper-container', {
                pagination: '.swiper-pagination',
                paginationClickable: true,
                loop:true,
                preloadImages: true,
                autoplay: 3000,
                onTap: function(sw, e) {
                    var dom = e.target,
                        wi;
                    if (dom.nodeName === 'DIV') {
                        if (!wi) {
                            wi = $(dom).width();
                        }
                        var style = window.getComputedStyle(document.getElementById('slide_list'));
                        var transf = style.webkitTransform;
                        var matrix = (transf.split('matrix')[1]).split(',');
                        var index = (Math.abs(Math.floor(matrix[4]))) / wi;
                        dom = $(slideList[index]).find('img');
                    }
                    var id = $(dom).attr('data-id');
                    var target = $(dom).attr('data-target');
                    if (typeof(target) != 'undefined' && typeof(id) != 'undefined') {
                        self.directToTargetPage(target, id);
                        Application.win.umengDiscoveryBanner(JSON.stringify({
                            discription: target+"_"+id
                        }));
                    }
                }
            });

            var slideList = $('.discovery_swiper');

            $(".right").css({"background-repeat":"no-repeat","background-size":"100% auto%","background-position":"0% 50%"});

            $('.discovery_swiper img').on("load", function() {
                $("#SwiperBox").height($('.discovery_swiper img').height());
                $(".swiper-container").height($('.discovery_swiper img').height());
            });
            Application.win.showTabBar();
        },
        onTapShopCataItem: function(e) {
            var id = $(e.currentTarget).data("id");
            Application.win.showShopListByShopType(JSON.stringify({
                id: id
            }));
        },
        onTapShopItem: function(e) {
            var id = $(e.currentTarget).data("id");

            if(Application.isAndroid){
                Application.win.showShopDetail(JSON.stringify({
                    id: id
                }));
            } else {
                Application.win.showShopByShopId(JSON.stringify({
                    id: id
                }));
            }
        },
        onTapCommodityType:function(e){
            var id = $(e.currentTarget).data("id"),
                title = $(e.currentTarget).data("type");
            Application.win.showBuyGoodsCategoryByGoodsTagId(JSON.stringify({
                id:id,
                title:title
            }));
        },
        onTapCommodityLeft:function(e){
            var id = $(e.currentTarget).data("id");
            Application.win.showGoodsDetail(JSON.stringify({
                id: id
            }));
        },
        onTapCommodityRight:function(e){
            var id = $(e.currentTarget).data("id");
            Application.win.showGoodsDetail(JSON.stringify({
                id: id
            }));
        },
        onTapSpecials: function(e) {
            var id = $(e.currentTarget).data("id"),
                surplus = $(e.currentTarget).data("count");

            Application.win.showGoodsDetail(JSON.stringify({
                id: id
            }));
        },
        onTapService: function(e) {
            var $dom = $(e.currentTarget),
                id = $dom.data("id"),
                title = $dom.attr("title"),
                targetType = $dom.data("target");

            if (targetType === "社区快送" && title.indexOf("暂未开通") < 0) {
                if(Application.isAndroid){
                    Application.win.showQucickSendView(JSON.stringify({
                        id: -1
                    }));
                } else {
                    Application.win.showFastDeliveryByGoodsType(JSON.stringify({
                        id: -1
                    }));
                }
                //Application.win.bridgeTest(JSON.stringify({id:'icepy'}),function(res){
                //});
            }
            if (targetType === "电商宅配") {
                Application.win.showShopList(JSON.stringify({
                    merchantType: "EC"
                }));
            }
           /* if (targetType === "周边商铺") {
                Application.win.showShopList(JSON.stringify({}));
            }*/
            if (targetType === "楼下店铺") {
                Application.win.showShopList(JSON.stringify({
                    "merchantType":"around"
                }));
            }
        },
        onTapNewService: function(e) {
            var el = $(e.currentTarget);
            var id = el.attr('data-id');
            var type = el.attr('data-type');
            this.directToTargetPage(type, id);
            Application.win.umengDiscoveryAdvert(JSON.stringify({
                discription: type+"_"+id
            }));
        },
        directToTargetPage: function(type, id) {
            switch (type) {
                case "shop":
                    if(Application.isAndroid){
                        Application.win.showShopDetail(JSON.stringify({
                            id: id
                        }));
                    } else {
                        Application.win.showShopByShopId(JSON.stringify({
                            id: id
                        }));
                    }
                    break;
                case "goods":
                    Application.win.showGoodsDetail(JSON.stringify({
                        id: id
                    }));
                    break;
                case "page":
                    if(id === 'groupbuying'){
                        window.router.navigate("groupbuying", {
                            trigger: true
                        });
                        return;
                    }
                    window.router.navigate("activity/" + id, {
                        trigger: true
                    });
                    break;
                case "url":
                    Application.win.loadOpenPage(JSON.stringify({
                        title: '',
                        url: id
                    }));
                    break;
                default:
                    break;
            }
        }
    });
    return discoveryIndexView;
});
