package cn.lejiayuan.Redesign.Function.topic

import android.content.Context
import android.graphics.Rect
import android.os.Bundle
import android.support.v4.app.DialogFragment
import android.text.TextUtils
import android.util.DisplayMetrics
import android.view.*
import android.view.ViewTreeObserver.OnGlobalLayoutListener
import android.view.inputmethod.InputMethodManager
import android.widget.LinearLayout
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Base.BaseFragment
import cn.lejiayuan.Redesign.Function.topic.model.SecondaryCommentListModel
import cn.lejiayuan.Redesign.Function.topic.model.TopicCommentListModel
import cn.lejiayuan.Redesign.Function.topic.model.req.ReplyReqModel
import cn.lejiayuan.Redesign.Http.Common.HttpRspCd
import cn.lejiayuan.Redesign.retrofit.ApiInterface
import cn.lejiayuan.common.Manager.WindowManager
import cn.lejiayuan.rxbus.RxBus
import cn.lejiayuan.rxbus.RXEvent.CommentRefreshEvent
import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import com.jakewharton.rxbinding2.view.RxView
import com.jakewharton.rxbinding2.widget.RxTextView
import com.orhanobut.logger.Logger
import io.reactivex.android.schedulers.AndroidSchedulers
import kotlinx.android.synthetic.main.layout_input_bottom.*
import java.util.*
import java.util.concurrent.TimeUnit


/**
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/31
 * Time: 下午3:44
 */
class CommentFragment : BaseFragment() {

    var listener: StateChangedListener? = null

    var replyModel: ReplyReqModel? = null

    enum class FromType {
        POST_DETAIL_COMMENT,
        POST_DETAIL_REPLY,
        POST_DETAIL_REPLY_OTHER
    }

    var from = ""
    var index = 0

    var beReplyUserName = ""

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        super.onCreateView(inflater, container, savedInstanceState)
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE)
        val view = inflater?.inflate(R.layout.layout_input_bottom, null)
        val win = dialog.window!!
        // 一定要设置Background，如果不设置，window属性设置无效
        win.setBackgroundDrawableResource(R.color.white)
        win.decorView.setPadding(0, 0, 0, 0)

        val dm = DisplayMetrics()
        activity!!.windowManager.defaultDisplay.getMetrics(dm)

        val params = win.attributes
        params.gravity = Gravity.BOTTOM
        params.width = ViewGroup.LayoutParams.MATCH_PARENT
        params.height = ViewGroup.LayoutParams.WRAP_CONTENT
        win.attributes = params

        return view!!
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        mIsSoftKeyboardShowing = false
        mKeyboardStateListeners = ArrayList()

        listener = StateChangedListener()
        replyModel = arguments!!.getSerializable(REPLY_MODEL) as ReplyReqModel?
        from = arguments!!.getString(REPLY_FROM)
        index = arguments!!.getInt(REPLY_INDEX, 0)
        beReplyUserName = arguments!!.getString(REPLY_BE_REPLY_USERNAME)

    }

    inner class StateChangedListener : OnSoftKeyboardStateChangedListener {
        override fun OnSoftKeyboardStateChanged(isKeyBoardShow: Boolean, keyboardHeight: Int) {
            if (rlBottomLayout != null) {
                val params = rlBottomLayout?.layoutParams as LinearLayout.LayoutParams
                params.bottomMargin = if (isKeyBoardShow) keyboardHeight else 0
                rlBottomLayout.layoutParams = params
                if (!isKeyBoardShow){
                    if (!TextUtils.isEmpty(etCommentInputView.text.toString())){
                        //存入缓存
                        PostCommentListActivity.MessageList.put(replyModel!!.postId, etCommentInputView.text.toString())
                    }
                    dismiss()
                }
            }
        }

    }

    private fun doComment() {
        PostCommentListActivity.MessageList.clear()
        btCommentSubmit.isEnabled = false
        replyModel?.commentContent = etCommentInputView.text.toString()

//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//                .mAddComment(replyModel, RequestUtil.getHeader(replyModel))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .filter { b ->
//                    btCommentSubmit.isEnabled = true
//                    showShortToast(b.rspInf)
//                    b.rspCd == HttpRspCd.SUCCESS
//                }
//                .map { result ->
//                    result.commentId
//                }
//                .subscribe({ result ->
//                    when (from) {
//                        FromType.POST_DETAIL_COMMENT.name -> {
//                            val commentModel = TopicCommentListModel()
//                            commentModel.commentId = result
//                            commentModel.createSmp = System.currentTimeMillis().toString()
//                            commentModel.commentUserNickName = SharedPreferencesUtil.getInstance(activity).getname()
//                            commentModel.commentContent = etCommentInputView.text.toString()
//                            commentModel.commentUserIconUrl = SharedPreferencesUtil.getInstance(activity).getimageurl()
//                            commentModel.commentUserId = SharedPreferencesUtil.getInstance(activity).getuserId().toString()
//                            commentModel.postId = replyModel?.postId!!
//                            val ref = CommentRefreshEvent(FromType.POST_DETAIL_COMMENT.name, 0, commentModel, null)
//                            RxBus.getInstance().post(ref)
//                            Logger.e("发送一个评论-----${FromType.POST_DETAIL_COMMENT.name}")
//                        }
//                        FromType.POST_DETAIL_REPLY.name -> {
//                            val secondaryModel = SecondaryCommentListModel()
//                            secondaryModel.commentId = result
//                            secondaryModel.beReplyUserId = replyModel?.commentUserId!!
//                            secondaryModel.commentContent = etCommentInputView.text.toString()
//                            secondaryModel.commentUserNickName = SharedPreferencesUtil.getInstance(activity).getname()
//                            secondaryModel.commentUserIconUrl = SharedPreferencesUtil.getInstance(activity).getimageurl()
//                            secondaryModel.commentUserId = SharedPreferencesUtil.getInstance(activity).getuserId().toString()
//                            secondaryModel.commentType = "reply"
//                            secondaryModel.beCommentId = replyModel?.beCommentId!!
//                            secondaryModel.beReplyUserNickName = ""
//                            secondaryModel.beReplyId = replyModel?.beReplyId!!
//                            secondaryModel.createSmp = System.currentTimeMillis().toString()
//                            secondaryModel.postId = replyModel?.postId!!
//                            val ref = CommentRefreshEvent(FromType.POST_DETAIL_REPLY.name, index, null, secondaryModel)
//                            RxBus.getInstance().post(ref)
//                            Logger.e("发送一个回复-----${FromType.POST_DETAIL_REPLY.name}")
//                        }
//
//                        FromType.POST_DETAIL_REPLY_OTHER.name -> {
//                            val secondaryModel = SecondaryCommentListModel()
//                            secondaryModel.commentId = result
//                            secondaryModel.beReplyUserId = replyModel?.commentUserId!!
//                            secondaryModel.commentContent = etCommentInputView.text.toString()
//                            secondaryModel.commentUserNickName = SharedPreferencesUtil.getInstance(activity).getname()
//                            secondaryModel.commentUserIconUrl = SharedPreferencesUtil.getInstance(activity).getimageurl()
//                            secondaryModel.commentUserId = SharedPreferencesUtil.getInstance(activity).getuserId().toString()
//                            secondaryModel.commentType = "reply"
//                            secondaryModel.beCommentId = replyModel?.beCommentId!!
//                            secondaryModel.beReplyUserNickName = beReplyUserName
//                            secondaryModel.beReplyId = replyModel?.beReplyId!!
//                            secondaryModel.createSmp = System.currentTimeMillis().toString()
//                            secondaryModel.postId = replyModel?.postId!!
//                            val ref = CommentRefreshEvent(FromType.POST_DETAIL_REPLY_OTHER.name, index, null, secondaryModel)
//                            RxBus.getInstance().post(ref)
//                            Logger.e("发送一个回复的回复-----${FromType.POST_DETAIL_REPLY_OTHER.name}")
//                        }
//
//                    }
//                    Logger.i(result)
//                    dismiss()
//                }, { error ->
//                    showShortToast(error.message)
//                    btCommentSubmit.isEnabled = true
//                })

    }

    override fun onStart() {
        super.onStart()
        RxTextView.textChanges(etCommentInputView)
                .compose(bindToLifecycle())
                .map { text -> text.length }
                .subscribe { p0 ->
                    btCommentSubmit.isEnabled = p0 > 0
                    tvContentNum.text = "$p0/200"
                }

        etCommentInputView.hint = if (beReplyUserName == "") "" else "回复@$beReplyUserName"
        //显示缓存的内容
        val cacheMessage = PostCommentListActivity.MessageList.get(replyModel?.postId)
        etCommentInputView.setText(cacheMessage)

        viewClose.setOnTouchListener({ _, _ ->
            dismiss()
            true
        })

        RxView.clicks(btCommentSubmit)
                .compose(bindToLifecycle())
                .filter {
                    btCommentSubmit.isEnabled
                }
                .debounce(500, TimeUnit.MILLISECONDS).observeOn(AndroidSchedulers.mainThread())
                .subscribe { doComment() }
        mLayoutChangeListener = OnGlobalLayoutListener {
            val r = Rect()
            activity?.window?.decorView?.getWindowVisibleDisplayFrame(r)
            //如果屏幕高度和Window可见区域高度差值大于整个屏幕高度的1/3，则表示软键盘显示中，否则软键盘为隐藏状态。
            val heightDifference = WindowManager.getWindowHeight(context) - (r.bottom - r.top)
            val isKeyboardShowing = heightDifference > WindowManager.getWindowHeight(context) / 3

            //如果之前软键盘状态为显示，现在为关闭，或者之前为关闭，现在为显示，则表示软键盘的状态发生了改变
            if ((mIsSoftKeyboardShowing && !isKeyboardShowing) || (!mIsSoftKeyboardShowing && isKeyboardShowing)) {
                mIsSoftKeyboardShowing = isKeyboardShowing
                mKeyboardStateListeners!!.forEach { listener -> listener.OnSoftKeyboardStateChanged(mIsSoftKeyboardShowing, heightDifference) }
            }
        }

        //注册布局变化监听
        activity?.window?.decorView?.viewTreeObserver?.addOnGlobalLayoutListener(mLayoutChangeListener)

        addSoftKeyboardChangedListener(listener)
    }

    override fun onDestroy() {
        super.onDestroy()
        removeSoftKeyboardChangedListener(listener)
    }

    override fun onResume() {
        super.onResume()
        etCommentInputView.isFocusableInTouchMode = true
        etCommentInputView.isFocusable = true
        etCommentInputView.requestFocus()
        val inputManager = etCommentInputView.context.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
        inputManager.showSoftInput(etCommentInputView, 0)
    }

    companion object {
        val REPLY_MODEL = "reply_model"
        val REPLY_FROM = "reply_from"
        val REPLY_INDEX = "reply_index"
        val REPLY_BE_REPLY_USERNAME = "reply_be_reply_user_name"
        fun newInstance(replyModel: ReplyReqModel, fromType: String, fromIndex: Int, beReplyUserName: String): CommentFragment {
            val mDialogFragment = CommentFragment()
            val bundle = Bundle()
            bundle.putSerializable(REPLY_MODEL, replyModel)
            bundle.putString(REPLY_FROM, fromType)
            bundle.putInt(REPLY_INDEX, fromIndex)
            bundle.putString(REPLY_BE_REPLY_USERNAME, beReplyUserName)
            mDialogFragment.arguments = bundle
            mDialogFragment.setStyle(DialogFragment.STYLE_NO_TITLE, R.style.DialogFragmentTheme)
            return mDialogFragment
        }
    }

    private var mKeyboardStateListeners: ArrayList<OnSoftKeyboardStateChangedListener>? = null      //软键盘状态监听列表
    private var mLayoutChangeListener: OnGlobalLayoutListener? = null
    private var mIsSoftKeyboardShowing: Boolean = false

    interface OnSoftKeyboardStateChangedListener {
        fun OnSoftKeyboardStateChanged(isKeyBoardShow: Boolean, keyboardHeight: Int)
    }

    //注册软键盘状态变化监听
    fun addSoftKeyboardChangedListener(listener: OnSoftKeyboardStateChangedListener?) {
        if (listener != null) {
            mKeyboardStateListeners?.add(listener)
        }
    }

    //取消软键盘状态变化监听
    fun removeSoftKeyboardChangedListener(listener: OnSoftKeyboardStateChangedListener?) {
        if (listener != null) {
            mKeyboardStateListeners?.remove(listener)
        }
    }

}