package cn.lejiayuan.Redesign.Function.topic

import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v4.app.FragmentManager
import android.support.v4.app.FragmentPagerAdapter
import android.support.v4.view.ViewPager
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Annotation.LAYOUT
import cn.lejiayuan.Redesign.Base.BaseActivity
import kotlinx.android.synthetic.main.activity_my_topic.*
import java.util.*

/**
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/14
 * Time: 下午3:07
 * 我参与的话题页面
 */
@LAYOUT(R.layout.activity_my_topic)
class MyTopicActivity : BaseActivity() {
    override fun layout() {

        setupViewPager()
        super.layout()
    }


    override fun initTitleManager() {
        initToolbar()
        toolbar.setCenterTitle(R.string.iEnjoyTopic)
    }

    private fun setupViewPager() {
        setupViewPager(viewPager)
        channelTabLayout.setupWithViewPager(viewPager)
    }

    private fun setupViewPager(viewPager: ViewPager) {
        val adapter = ViewPagerAdapter(supportFragmentManager)

        val rankingByDay = ReplyListFragment()
        val dayBundle = Bundle()
        rankingByDay.arguments = dayBundle


        val rankingByWeek = MyTopicFragment()
        val weekBundle = Bundle()
        rankingByWeek.arguments = weekBundle

        adapter.addFrag(rankingByDay, getString(R.string.topic_table_me_replay))
        adapter.addFrag(rankingByWeek, getString(R.string.topic_table_me_publish))

        viewPager.adapter = adapter
        viewPager.offscreenPageLimit = 5
    }

    internal class ViewPagerAdapter(manager: FragmentManager) : FragmentPagerAdapter(manager) {

        private val mFragmentList = ArrayList<Fragment>()
        private val mFragmentTitleList = ArrayList<String>()

        override fun getItem(position: Int): Fragment = mFragmentList[position]

        override fun getCount(): Int = mFragmentList.size

        fun addFrag(fragment: Fragment, title: String) {
            mFragmentList.add(fragment)
            mFragmentTitleList.add(title)
        }

        override fun getPageTitle(position: Int): CharSequence = mFragmentTitleList[position]
    }
}
