package cn.lejiayuan.Redesign.Function.topic

import android.support.v4.widget.SwipeRefreshLayout
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Base.BaseFragment
import cn.lejiayuan.Redesign.Function.topic.adapter.MyPostAdapter
import cn.lejiayuan.Redesign.Function.topic.model.req.LatestTopicReqModel
import cn.lejiayuan.Redesign.retrofit.ApiInterface
import cn.lejiayuan.rxbus.RxBus
import cn.lejiayuan.rxbus.RXEvent.PostRefreshEvent
import cn.lejiayuan.rxbus.RXEvent.TopicModelRefreshEvent
import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxRequestStatus
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.common.utils.SharedPreferencesUtil

/**
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/21
 * Time: 下午6:35
 * 我发布的话题
 */
class MyTopicFragment : BaseFragment() {
    var refreshView: SwipeRefreshLayout? = null
    var tempFirstPostId = ""

    val mAdapter = MyPostAdapter()

    override fun layout(inflater: LayoutInflater?): View {

        val list = RecyclerView(this.context!!)
        refreshView = SwipeRefreshLayout(this.context!!)
        list.layoutManager = LinearLayoutManager(this.context!!)

        //显示删除按钮
        mAdapter.setShowDelButton(true)
        list.adapter = mAdapter

        recvLoadPostList()

        refreshView?.addView(list)
        refreshView?.setColorSchemeColors(resources.getColor(R.color.colorPrimary))
        refreshView?.setOnRefreshListener {
            getPostList(true)
        }

        mAdapter.setOnLoadMoreListener({ getPostList(false) }, list)

        RxBus.getInstance().toObservable(PostRefreshEvent::class.java)
                .compose(bindToLifecycle())
                .filter { b -> TextUtils.equals(PostCommentListActivity.FromType.ME.name, b.fromType) }
                .filter { b -> mAdapter.data[b.fromIndex] != null }
                .subscribe({ model ->
                    model.fromIndex
                    mAdapter.data[model.fromIndex] = model.postModel
                    mAdapter.notifyItemChanged(model.fromIndex)
                }, {})
        return refreshView as SwipeRefreshLayout
    }


    /**
     * 加载"我发布的"数据(最新页面通知过来)
     */
    private fun recvLoadPostList() {
        RxBus.getInstance().toObservable(TopicModelRefreshEvent::class.java)
                .compose(bindToLifecycle())
                .subscribe({ event ->
                    tempFirstPostId = event.mFirstPostID
                    getPostList(true)
                }, { onError ->
                })

    }

    private fun getPostList(isRefresh: Boolean) {
        val req = LatestTopicReqModel()

//        req.doLikesUserId = SharedPreferencesUtil.getInstance(context).getuserId().toString()
//        req.userId = SharedPreferencesUtil.getInstance(context).getuserId().toString()
//        req.postId = if (!isRefresh && mAdapter.data.size > 0) mAdapter.data[mAdapter.data.size - 1].postId else "0"
//        req.communityId = SharedPreferencesUtil.getInstance(context).areaId.toString()
//        req.firstPostId = tempFirstPostId
//
//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java).mGetTableNewPostList(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .map { list ->
//                    {
//                        refreshView?.isRefreshing = false
//                        if (list.postNewCount > 0){
//                            //显示红点
//                            RxBus.getInstance().post(TopicListsActivity.TOPIC_TAB_NEW_RED_DOT_SHOW)
//                        }else{
//                            RxBus.getInstance().post(TopicListsActivity.TOPIC_TAB_NEW_RED_DOT_HIDE)
//                        }
//                        list.postList
//                    }
//                }
//                .filter { list ->
//                    if (list.invoke() == null || (list.invoke() != null && list.invoke()!!.isEmpty()))
//                        mAdapter.loadMoreEnd()
//                    list.invoke()?.size!! > 0
//                }
//                .subscribe({ list ->
//                    mAdapter.loadMoreComplete()
//                    if (isRefresh) {
//                        mAdapter.setNewData(list.invoke())
//                    } else {
//                        mAdapter.addData(list.invoke()!!)
//                    }
//                }, { error ->
//                    mAdapter.loadMoreFail()
//                    refreshView?.isRefreshing = false
//                    showShortToast(error.message)
//                })

    }
}