package cn.lejiayuan.Redesign.Function.topic

import android.content.Intent
import android.net.Uri
import android.text.TextUtils
import android.util.Log
import android.view.inputmethod.InputMethodManager
import android.widget.Toast
import cn.lejiayuan.BuildConfig
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Annotation.LAYOUT
import cn.lejiayuan.Redesign.Base.BaseActivity
import cn.lejiayuan.Redesign.Base.BaseAdapter
import cn.lejiayuan.Redesign.Function.Commodity.property.adapter.AddPropertyGridAdapter
import cn.lejiayuan.Redesign.Function.Commodity.property.model.bean.ImageBean
import cn.lejiayuan.Redesign.Function.UserPerson.Model.Family.UploadImgResp
import cn.lejiayuan.Redesign.Function.topic.model.PostListModel
import cn.lejiayuan.Redesign.Function.topic.model.req.NewPostReqModel
import cn.lejiayuan.Redesign.Http.Common.HttpRspCd
import cn.lejiayuan.rxbus.RxBus
import cn.lejiayuan.Redesign.View.AnimationDialog
import cn.lejiayuan.Redesign.retrofit.ApiInterface
import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.bean.PhotoInfo
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import cn.lejiayuan.fragment.GlideImageLoader
import cn.lejiayuan.lib.utils.NoteUtil
import cn.lejiayuan.lib.utils.ProgressDialogUtil
import com.android.volley.VolleyError
import com.beijing.ljy.frame.net.upload.MultiPartStringRequest
import com.beijing.ljy.frame.net.upload.UploadUtil
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import com.jakewharton.rxbinding2.view.RxView
import com.jakewharton.rxbinding2.widget.RxTextView
import com.lzy.imagepicker.ImagePicker
import com.lzy.imagepicker.bean.ImageItem
import com.lzy.imagepicker.ui.ImageGridActivity
import com.lzy.imagepicker.view.CropImageView
import com.orhanobut.logger.Logger
import io.reactivex.Flowable
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.disposables.Disposable
import kotlinx.android.synthetic.main.activity_new_topic.*
import java.io.File
import java.util.*
import java.util.concurrent.TimeUnit
import kotlin.collections.ArrayList

/**
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/21
 * Time: 上午11:11
 */
@LAYOUT(R.layout.activity_new_topic)
class NewTopicActivity : BaseActivity() {

    private lateinit var picList: ArrayList<ImageBean> //上传图片地址列表
    private lateinit var imgList: ArrayList<ImageBean>//上传成功的图片对象列表
    private lateinit var failPicList: ArrayList<ImageBean>//上传图片地址列表
    private lateinit var files: ArrayList<File>//上传图片地址列表

    private var picAnimationDialog: AnimationDialog? = null
    private var imm: InputMethodManager? = null
    private var disposable: Disposable? = null


    private val REPAIR_UPLOAD_IMG = "LeHomeApp/repair_select.jpg"
    private val REPAIR_UPLOAD_CAMERAIMG = "/repair_camera.jpg"

    private val CAMERA_QRCODE = 100
    //拍照
    val TAKINH_PICTURES = 0

    //选相册
    val ALUM = 1
    //剪切
    val CLIP = 2

    private var uriList: ArrayList<String>? = ArrayList()

    private var gridAdapter: AddPropertyGridAdapter = AddPropertyGridAdapter()
    val imagePicker = ImagePicker.getInstance()
    private lateinit var cropTempFile: File

    private var index = 0


    companion object {
        val ACTIVITY_ID = "activityId"
        val TITLE = "title"
    }


    var activityId = "2017121300001002000000000018"
    var title = "测试新发话题最低访问量为10"


    override fun initTitleManager() {
        initToolbar()
        toolbar.setCenterTitle(R.string.saySomeThing)
        toolbar.rightText.setText(R.string.send)
        toolbar.rightText.setTextColor(resources.getColor(R.color.colorPrimary))
    }

    override fun layout() {

//        activityId = intent.getStringExtra(ACTIVITY_ID)
//        title = intent.getStringExtra(TITLE)

        RxTextView.textChanges(etNewTopicInput)
                .compose(bindToLifecycle())
                .map { text -> text.length }
                .subscribe { p0 ->
                    tvNewTopicTextLength.text = "$p0/1000"
                }


        disposable = Flowable.timer(1, TimeUnit.SECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe({
                    imm = this@NewTopicActivity.getSystemService(android.content.Context.INPUT_METHOD_SERVICE) as InputMethodManager?;
                    imm!!.showSoftInput(etNewTopicInput,InputMethodManager.SHOW_FORCED);
                })


        imagePicker.imageLoader = GlideImageLoader()   //设置图片加载器
        imagePicker.isShowCamera = true  //显示拍照按钮
        imagePicker.isCrop = true        //允许裁剪（单选才有效）
        imagePicker.isSaveRectangle = true //是否按矩形区域保存
        imagePicker.selectLimit = 9 - gridAdapter.count + 1    //选中数量限制
        imagePicker.style = CropImageView.Style.RECTANGLE  //裁剪框的形状
        imagePicker.focusWidth = 800   //裁剪框的宽度。单位像素（圆形自动取宽高最小值）
        imagePicker.focusHeight = 800  //裁剪框的高度。单位像素（圆形自动取宽高最小值）
        imagePicker.outPutX = 1000//保存文件的宽度。单位像素
        imagePicker.outPutY = 1000//保存文件的高度。单位像素

        picList = ArrayList()
        failPicList = ArrayList()
        imgList = ArrayList()
        files = ArrayList()

        gvImagePicker.setOnItemClickListener { _, _, position, _ ->
            run {
                try {
                    if (picList.size < 10) {
                        if (picList[position].isType) {
//                            addPic()
                            openImageSelect()
                        } else {
                            uriList?.let { gotoShowImageActivity(it, position) }
                        }
                    } else {
                        if (picList[position].isType) {
                            showShortToast("最多只能选择9张照片")
                        } else {
                            uriList?.let { gotoShowImageActivity(it, position) }
                        }
                    }
                } catch (e: Exception) {
                    Logger.e(e.message)
                }
            }
        }

        val imageBean = ImageBean()
        imageBean.isType = true
        imageBean.index = 10000
        picList.add(imageBean)

        gridAdapter = AddPropertyGridAdapter()
        gridAdapter.context = this@NewTopicActivity
        gridAdapter.list = picList
        gridAdapter.listener = BaseAdapter.AdapterItemListener { objects ->
            val imageBean1 = objects[0] as ImageBean
            files.remove(imageBean1.file)
            picList.remove(imageBean1)
            uriList?.remove(imageBean1.uri)
            removeListItem(failPicList, imageBean1)//删除failPiclist中的对应图片
            removeListItem(imgList, imageBean1)//删除imgList中的对应图片

            Log.i("fyg", "failPicList:" + failPicList.size + "-imgList:-" + imgList.size)


            if (picList.size < 10) {
                //存在
                val isExist = picList.any {
                    //检测列表中是否有添加控件
                    it.isType
                }//默认不存在
                if (!isExist) {//如果不存在则增加添加控件
                    val image = ImageBean()
                    image.isType = true
                    image.index = 10000
                    picList.add(image)
                }
            }
            collection(picList)
            gridAdapter.notifyDataSetChanged()
            true
        }

        gvImagePicker.adapter = gridAdapter
        gridAdapter.notifyDataSetChanged()

        super.layout()
    }

    fun openImageSelect() {
        imagePicker.selectLimit = 9 - gridAdapter.count + 1
        val intent = Intent(this, ImageGridActivity::class.java)
        startActivityForResult(intent, 999)
    }

    override fun onStart() {
        super.onStart()
        RxView.clicks(toolbar.rightText).debounce(500, TimeUnit.MILLISECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe({ newPost() }, { error -> Logger.e(error.message) })
    }


    /**
     * Title: 跳转到浏览图片页面
     * Description:
     *
     * @param
     * @author xie_lp
     * @data 16/5/27 下午2:12
     */
    private fun gotoShowImageActivity(list: ArrayList<String>, position: Int) {

        val pageList = ArrayList<PhotoInfo>()

        list.forEach { url ->
            run {
                val photoInfo = PhotoInfo()
                photoInfo.picUrl = url
                pageList.add(photoInfo)
            }
        }

        val intent = Intent(this@NewTopicActivity, ImageGalleryActivity::class.java)
        intent.putExtra(ImageGalleryActivity.IMAGE_GALLERY_INDEX, position)
        intent.putParcelableArrayListExtra(ImageGalleryActivity.IMAGE_GALLERY_IMAGES_INFO, pageList)
        startActivity(intent)
    }

    /**
     * Title:
     * Description:删除图像列表中的指定项
     *
     * @param
     * @author xie_lp
     * @data 16/11/9 上午9:54
     */
    private fun removeListItem(list: ArrayList<ImageBean>?, imageBean: ImageBean) {
        if (null != list) {
            //存在
            val isExist = list.any {
                //检测未上传列表中是否有此图片
                it.index == imageBean.index
            }//默认不存在
            if (isExist) {//如果未上传列表中有此图片,则移除此对象
                list.forEach { item ->
                    run {
                        if (item.index == imageBean.index) {
                            list.remove(item)
                            return
                        }
                    }
                }
            }
        }
    }


    /**
     * Title:
     * Description:将list排序
     *
     * @param
     * @author xie_lp
     * @data 16/3/31 下午1:35
     */
    private fun collection(list: ArrayList<ImageBean>) {
        Collections.sort(list) { imageBean, t1 -> imageBean.index - t1.index }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == ImagePicker.RESULT_CODE_ITEMS) {
            if (data != null && requestCode == 999) {
                val images: ArrayList<ImageItem> = data.getSerializableExtra(ImagePicker.EXTRA_RESULT_ITEMS) as ArrayList<ImageItem>

                images.forEach { item ->
                    run {
                        val imageBean = ImageBean()
                        imageBean.isType = false
//                        imageBean.bitmap = FileUtils.decodeUriAsBitmap(this, Uri.fromFile(File(item.path)))
                        imageBean.file = File(item.path)
                        imageBean.index = index
                        imageBean.uri = Uri.fromFile(File(item.path)).toString()
                        uriList?.add(imageBean.uri)
                        picList.add(imageBean)
                        index++
                        if (picList.size > 10) {
                            picList.indices
                                    .filter { picList[it].isType }
                                    .forEach { picList.remove(picList[it]) }
                        }
                        collection(picList)
                        gridAdapter.notifyDataSetChanged()
                        uploadImg(imageBean, false)
                    }
                }
            } else {
                Toast.makeText(this, "没有数据", Toast.LENGTH_SHORT).show()
            }
        }
    }


    internal var progressDialog: ProgressDialogUtil? = null

    /**
     * Title:
     * Description:上传图片
     *
     * @param
     * @author xie_lp
     * @data 16/11/1 下午5:24
     */
    private fun uploadImg(imageBean: ImageBean, isCommit: Boolean) {
        val uploadFiles = ArrayList<File>()
        uploadFiles.add(imageBean.file)
        val mapFiles = HashMap<String, List<File>>()
        mapFiles.put("resources", uploadFiles)
        val params = HashMap<String, String>()
        params.put("path", "authentucate")
        val uploadUrl = BuildConfig.urlNewMAPI + "userIdentifyChange/uploadOssFile.do"
        if (!isCommit) {
            failPicList.add(imageBean)
        }
        UploadUtil.upLoad(this@NewTopicActivity, uploadUrl, mapFiles, params, object : MultiPartStringRequest.FileUpLoadResult {
            override fun onSuccess(response: String) {
                try {
                    val gson = Gson()
                    val type = object : TypeToken<UploadImgResp>() {

                    }
                    val queryTranRecResp = gson.fromJson<UploadImgResp>(
                            response, type.type)
                    if (queryTranRecResp.isSuccess) {
                        val successImg = ImageBean()
                        successImg.id = queryTranRecResp.data
                        successImg.index = imageBean.index
//                        successImg.bitmap = imageBean.bitmap
                        successImg.uri = queryTranRecResp.prefix + queryTranRecResp.relativeUrl
                        //                                removeListItem(imgList, successImg);//去重
                        //存在
                        val isExist = imgList.any {
                            //检测未上传列表中是否有此图片
                            it.index == successImg.index
                        }//默认不存在
                        if (isExist) {//如果未上传列表中有此图片,则移除此对象
                            imgList.remove(successImg)
                        }
                        imgList.add(successImg)//上传成功的图片对象
                        removeListItem(failPicList, imageBean)
                        if (isCommit) {//是否为提交操作
                            newPost()
                        }
                    } else {
                        if (isCommit) {
                            progressDialog?.dismiss()
                            if (!TextUtils.isEmpty(queryTranRecResp.errorMsg)) {
                                showShortToast(queryTranRecResp.errorMsg)
                            } else {
                                showShortToast("图片上传失败")
                            }
                        } else {
                            failPicList.add(imageBean)
                        }
                    }
                } catch (e: Exception) {
                    NoteUtil.Log(e.message)
                    if (isCommit) {
                        progressDialog?.dismiss()
                        showShortToast("图片上传失败")
                    }
                }

            }

            override fun onError(error: VolleyError) {
                if (isCommit) {
                    progressDialog?.dismiss()
                    val ClassStr = error.javaClass
                    if (ClassStr.name == "com.android.volley.NoConnectionError" || ClassStr.name == "com.android.volley.TimeoutError") {
                        showShortToast("上传失败,请在网速良好的环境下提交!")
                    } else {
                        showShortToast("图片上传失败")
                    }
                }
            }
        }

        )
    }

    fun newPost() {
        if (etNewTopicInput.text.isEmpty()) {
            showShortToast(resources.getString(R.string.topic_postcomment_07))
            return
        }

        if (null == progressDialog) {
            progressDialog = ProgressDialogUtil(this@NewTopicActivity, "正在提交")
        }
        progressDialog?.show()
        if (failPicList.size > 0) {
            uploadImg(failPicList[0], true)
            return
        }

        val req = NewPostReqModel()
        req.activityId = activityId
        req.communityId = SharedPreferencesUtil.getInstance(this).areaId.toString()
        req.content = etNewTopicInput.text.toString()
        req.title = title
        req.userId = SharedPreferencesUtil.getInstance(this).getuserId().toString()
        req.pageList = ArrayList()
        //排序
        //collection(imgList)
        imgList.forEach { model -> req.pageList!!.add(PhotoInfo(model.id, model.uri, model.uri)) }

//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//            .mNewPost(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .filter { b ->
//                    showShortToast(b.rspInf)
//                    picAnimationDialog?.dismiss()
//                    b.rspCd == HttpRspCd.SUCCESS
//                }
//                .subscribe({ result ->
//                    val model = PostListModel()
//                    model.activityId = req.activityId
//                    model.pageList = req.pageList!!
//                    model.nickName = SharedPreferencesUtil.getInstance(this).getname()
//                    model.iconUrl = SharedPreferencesUtil.getInstance(this).getimageurl()
//                    model.communityName = SharedPreferencesUtil.getInstance(this).areaName
//                    model.postTime = System.currentTimeMillis().toString()
//                    model.content = etNewTopicInput.text.toString()
//                    model.postId = result.postId
//                    model.userId = SharedPreferencesUtil.getInstance(this).getuserId().toString()
//                    model.title = title
//                    RxBus.getInstance().post(model)
//                    finish()
//                }, { error ->
//                    picAnimationDialog?.dismiss()
//                    progressDialog?.dismiss()
//                    showShortToast(error.message)
//                })
    }

    override fun onDestroy() {
        if (disposable != null && !disposable!!.isDisposed()) {
            disposable!!.dispose()
        }
        picAnimationDialog?.dismiss()
        picAnimationDialog = null
        super.onDestroy()
    }
}