package cn.lejiayuan.Redesign.Function.topic

import android.content.Context
import android.content.Intent
import android.os.Handler
import android.os.Message
import android.support.v7.widget.LinearLayoutManager
import android.text.TextUtils
import android.view.animation.Animation
import android.view.animation.AnimationUtils
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Annotation.LAYOUT
import cn.lejiayuan.Redesign.Base.BaseActivity
import cn.lejiayuan.Redesign.Dialog.Base.DialogView
import cn.lejiayuan.Redesign.Function.Commodity.UI.Property.RedPocketAndCardRsp
import cn.lejiayuan.activity.find.redpackage.AdRedPacketDetailActivity
import cn.lejiayuan.Redesign.Function.Friendly.view.AdPacketGetDialogView
import cn.lejiayuan.Redesign.Function.OldClass.login.LoginActivity
import cn.lejiayuan.Redesign.Function.topic.adapter.PostCommentAdapter
import cn.lejiayuan.Redesign.Function.topic.model.*
import cn.lejiayuan.Redesign.Function.topic.model.req.LikeReqModel
import cn.lejiayuan.Redesign.Function.topic.model.req.PostCommentListReqModel
import cn.lejiayuan.Redesign.Function.topic.model.req.PostDetailReqModel
import cn.lejiayuan.Redesign.Function.topic.model.req.ReplyReqModel
import cn.lejiayuan.Redesign.Function.topic.model.response.PostCommentListResponseModel
import cn.lejiayuan.Redesign.Http.Common.HttpRspCd
import cn.lejiayuan.rxbus.RxBus
import cn.lejiayuan.rxbus.RXEvent.CommentRefreshEvent
import cn.lejiayuan.rxbus.RXEvent.PostRefreshEvent

import cn.lejiayuan.Redesign.View.OpenDoorPopCardDialog
import cn.lejiayuan.Redesign.retrofit.ApiInterface
import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxRequestStatus
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.analysis.AnalysisEventUtil
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.bean.redPacket.AdRedPacketReq
import cn.lejiayuan.bean.redPacket.responseBean.HttpOpenRedPacketRspBean
import cn.lejiayuan.bean.redPacket.responseBean.HttpOpenRedPacketRsqBean
import cn.lejiayuan.bean.redPacket.RedPacketBean
import cn.lejiayuan.bean.square.responseBean.UserHouseItem
import cn.lejiayuan.cachelib.SPCache
import cn.lejiayuan.common.utils.ShareUtils
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import cn.lejiayuan.constance.Constance
import cn.lejiayuan.common.utils.ShowUtil
import cn.lejiayuan.common.utils.ToastUtil
import com.android.volley.VolleyError
import com.beijing.ljy.frame.net.IJsonBeanListenerImpl
import com.beijing.ljy.frame.net.JsonBeanRequestEngine
import com.beijing.ljy.frame.util.ProgressDialogUtil
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import com.jakewharton.rxbinding2.view.RxView
import com.orhanobut.logger.Logger
import io.reactivex.Observable
import io.reactivex.android.schedulers.AndroidSchedulers
import kotlinx.android.synthetic.main.activity_swap_list_primary.*
import kotlinx.android.synthetic.main.layout_input_bottom_view.*
import org.reactivestreams.Publisher
import java.util.concurrent.TimeUnit

/**
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/18
 * Time: 上午11:36
 */
@LAYOUT(R.layout.activity_swap_list_primary)
class PostCommentListActivity : BaseActivity() {

    private var dialogUtil: ProgressDialogUtil? = null
    private var openDoorPopCardDialog: OpenDoorPopCardDialog? = null
    @Transient private var getDialog: cn.lejiayuan.Redesign.Dialog.Base.AnimationDialog? = null
    private var areaId: String? = null

    val mAdapter = PostCommentAdapter()
    var postModel: PostListModel? = PostListModel()

    enum class FromType {
        LIST, ME
    }

    companion object {
        var POST_FROM = "post_from"
        var POST_INDEX = "post_index"
        var POST_INFO = "post_info"
        var POST_ID = "post_id"
        //用于缓存CommentFragment评论框中的内容
        var MessageList = HashMap<String, String>()
    }

    var from = ""
    var index = 0
    var likeAnim: Animation? = null
    var tempPostid = ""

    override fun initTitleManager() {
        initToolbar()
        toolbar.setNavigationIcon(R.drawable.nav_back_button_white)
    }

    override fun layout() {
        val intent = intent
        val action = intent.action
        if (Intent.ACTION_VIEW == action) {
            val uri = intent.data
            postModel?.postId = uri.getQueryParameter("postId")
        } else {
            postModel = intent.getParcelableExtra(POST_INFO)?:null
            tempPostid = intent.getStringExtra(POST_ID)?:""
            if (postModel != null){
                tempPostid = postModel!!.postId
            }

        }
        from = intent.getStringExtra(POST_FROM) ?: ""
        index = intent.getIntExtra(POST_INDEX, 0)


        rvList.layoutManager = LinearLayoutManager(this)
        rvList.adapter = mAdapter
        mAdapter.supportFragmentManager = supportFragmentManager
        if (postModel == null){
            postModel = PostListModel()
        }
        mAdapter.mTopicModel = postModel

        mAdapter.addData(PostCommentAdapterModel(true, ""))
        mAdapter.notifyDataSetChanged()

        likeAnim = AnimationUtils.loadAnimation(this, R.anim.like_anim)


        openDoorPopCardDialog = OpenDoorPopCardDialog(this)

        doLike()

        doShare()

        doInput()

        mAdapter.setOnLoadMoreListener({ getPostCommentList(false) }, rvList)

        refreshView.setColorSchemeColors(resources.getColor(R.color.colorPrimary))
        refreshView.setOnRefreshListener {
            getPostDetail()
            getPostCommentList(true)
        }
        getPostDetail()
        getPostCommentList(true)

        RxBus.getInstance()
                .toObservable(CommentRefreshEvent::class.java)
                .compose(bindToLifecycle())
                .subscribe(
                        { result ->
                            when (result.fromType) {
                                CommentFragment.FromType.POST_DETAIL_COMMENT.name -> {
                                    mAdapter.addData(1, PostCommentAdapterModel(result.commentModel!!))
                                    Logger.e("收到一个评论")
                                    //再调用一下"获取红包或奖金"的接口
                                    requertAdvertPrize()
                                }

                                CommentFragment.FromType.POST_DETAIL_REPLY.name -> {
                                    val replyList = ArrayList<SecondaryCommentListModel>()
                                    if (mAdapter.data[result.fromIndex - mAdapter.headerLayoutCount].t.replyList != null) {
                                        replyList.addAll(mAdapter.data[result.fromIndex - mAdapter.headerLayoutCount].t.replyList!!)
                                    }
                                    replyList.add(result.secondaryModel!!)
                                    mAdapter.data[result.fromIndex - mAdapter.headerLayoutCount].t.replyList = replyList
                                    mAdapter.notifyItemChanged(result.fromIndex + mAdapter.headerLayoutCount)
                                    Logger.e("收到一个回复")
                                }

                                CommentFragment.FromType.POST_DETAIL_REPLY_OTHER.name -> {
                                    val replyList = ArrayList<SecondaryCommentListModel>()
                                    if (mAdapter.data[result.fromIndex - mAdapter.headerLayoutCount].t.replyList != null) {
                                        replyList.addAll(mAdapter.data[result.fromIndex - mAdapter.headerLayoutCount].t.replyList!!)
                                    }
                                    replyList.add(result.secondaryModel!!)
                                    mAdapter.data[result.fromIndex - mAdapter.headerLayoutCount].t.replyList = replyList
                                    mAdapter.notifyItemChanged(result.fromIndex + mAdapter.headerLayoutCount)
                                    Logger.e("收到一个回复的回复")
                                }
                            }

                            postModel?.commentNumber = (postModel?.commentNumber?.toInt()!! + 1).toString()
                            mAdapter.mTopicModel = postModel
                            mAdapter.notifyItemChanged(0)
                            if (from != "") {
                                RxBus.getInstance().post(PostRefreshEvent(from, index, postModel))
                            }

                        }, { error -> Logger.e(error.message) })

        super.layout()
    }

    private fun getPostDetail() {
        val req = PostDetailReqModel(tempPostid ?: "", SharedPreferencesUtil.getInstance(this).getuserId().toString())
//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//            .mGetPostDetail(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .subscribe({ result ->
//                    postModel?.nickName = result.nickName
//                    postModel?.iconUrl = result.iconUrl
//                    postModel?.title = result.title
//                    postModel?.content = result.content
//                    postModel?.likesNumber = result.likesNumber
//                    postModel?.isDoLikes = result.isDoLikes
//                    postModel?.communityName = result.communityName
//                    postModel?.commentNumber = result.commentNumber
//                    postModel?.pageList = result.pageList
//                    postModel?.userId = result.userId
//                    postModel?.postId = result.postId
//                    postModel?.activityId = result.activityId
//                    postModel?.postTime = result.postTime
//                    postModel?.communityId = result.communityId
//                    postModel?.postType = result.postType
//
//
//                    tvLikeNum.text = postModel?.likesNumber
//                    ivLikeImg.setImageResource(if (!postModel?.isDoLikes.equals("Yes")) R.mipmap.courenao_button_zan_gray else R.mipmap.courenao_button_zan_orange)
//                    mAdapter.mTopicModel = postModel
//                    mAdapter.notifyItemChanged(0)
//                    if (from != "") {
//                        RxBus.getInstance().post(PostRefreshEvent(from, index, postModel))
//                    }
//                }, {
//                    error->
//                    Logger.e(error.message)
//                })
    }

    var isLoading = false

    //获取该帖子评论列表
    private fun getPostCommentList(isRefresh: Boolean) {
        if (isLoading) {
            mAdapter.loadMoreComplete()
            return
        }

        isLoading = true
        if (isRefresh)
            mAdapter.setEnableLoadMore(true)

        val req = PostCommentListReqModel()
        req.commentId = if (!isRefresh && mAdapter.data.size > 1) mAdapter.data[mAdapter.data.size - 1].t.commentId else "0"
        req.postId = tempPostid

//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//            .mGetPostCommentList(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .flatMap { responseModel: PostCommentListResponseModel ->
//                    Publisher<List<TopicCommentListModel>> { subscriber ->
//                        subscriber.onNext(responseModel.commentList)
//                    }
//                }
//                .filter { list ->
//                    if (list.isEmpty()) {
//                        mAdapter.loadMoreEnd()
//                    } else {
//                        mAdapter.loadMoreComplete()
//                    }
//                    refreshView.isRefreshing = false
//                    isLoading = false
//                    list.isNotEmpty()
//                }
//                .flatMap { list: List<TopicCommentListModel> ->
//                    Observable.fromIterable(list).flatMap({ topicCommentListModel: TopicCommentListModel ->
//                        Observable.just(PostCommentAdapterModel(topicCommentListModel))
//                    }).toList().toFlowable()
//                }
//                .subscribe({ list ->
//                    if (isRefresh) {
//                        list.add(0, PostCommentAdapterModel(true, ""))
//                        mAdapter.setNewData(list)
//                        mAdapter.disableLoadMoreIfNotFullPage()
//                    } else {
//                        mAdapter.addData(list)
//                    }
//                }, { error ->
//                    mAdapter.loadMoreFail()
//                    refreshView.isRefreshing = false
//                    isLoading = false
//                    showShortToast(error.message)
//                })
    }



    /**
     * 调用红包或奖金接口
     */
    private fun requertAdvertPrize() {

        val userId = SharedPreferencesUtil.getInstance(applicationContext).getuserId().toString()
        val appVsersion = Constance.getAppCodeVersion()
        areaId = SharedPreferencesUtil.getInstance(applicationContext).areaId.toString()

        var isRequest = false
        val fromJson = SPCache.manager(this).get(Constance.FAMILY_USER_HOUSES_KEY);
        val type = object : TypeToken<ArrayList<UserHouseItem>>() {}.getType()
        var houseList = ArrayList<UserHouseItem>()
        houseList = Gson().fromJson(fromJson, type);
        if (houseList != null && houseList.size>0){
            for (house in houseList){
                if (areaId.equals(house.id)){
                    isRequest = true
                    break
                }
            }
        }
        if (!isRequest){
            return
        }

        val adRedPacketReq = AdRedPacketReq()
//        adRedPacketReq.communityId = areaId
//        adRedPacketReq.userId = userId
//        adRedPacketReq.appVersion = appVsersion
        adRedPacketReq.channelType = "COMMENT" //评论

//        HttpEngine.getInstance().getsApiService()
//                .mGetAdvertPrizeGain(adRedPacketReq, RequestUtil.getHeader(adRedPacketReq))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .subscribe({ response ->
//                    if (response != null){
//                        val msg = Message()
//                        if (!TextUtils.equals("CARD_COLLECTING", response.getType())) {
//                            val redPacketBean = response.getRedPacketBean()
//                            redPacketBean.setId(response.getId() + "")
//                            msg.obj = redPacketBean
//                            msg.what = 2
//                            mHandler.handleMessage(msg)
//                        } else {
//                            msg.obj = response
//                            msg.what = 3
//                            mHandler.handleMessage(msg)
//                        }
//                    }
//                }, { error ->
//                    showShortToast(error.message)
//                })


    }

     var mHandler: Handler = object : Handler() {
        override fun handleMessage(msg: Message) {
            super.handleMessage(msg)
            when (msg.what) {
                2 -> {
                    val redPacketBean = msg.obj as RedPacketBean
                    showRedPacketGotDialog(this@PostCommentListActivity, redPacketBean)
                }
                3 -> {
                    val response = msg.obj as RedPocketAndCardRsp
                    openDoorPopCardDialog!!.show()
                    openDoorPopCardDialog!!.setResponse(response)
//                    if (TextUtils.isEmpty(areaId)) {
//                        openDoorPopCardDialog!!.setCellId(0)
//                    } else {
//                        openDoorPopCardDialog!!.setCellId(Integer.parseInt(areaId))
//                    }
                }
            }
        }
    }



    private fun showRedPacketGotDialog(context: Context, redPacketBean: RedPacketBean) {
        if (null != getDialog && getDialog!!.isShowing()) {
            return
        }
        val adPacketGetDialogView = AdPacketGetDialogView(context, redPacketBean)
        adPacketGetDialogView.dialogViewListener = DialogView.DialogViewListener { parames ->
            val parame = parames[0] as String
            if (parame == "getview" || parame == "themeRed") {
                adPacketGetDialogView.isGotRedPacket()
                adPacketGetDialogView.canClick(false)
                openRedPacket(context, redPacketBean.id, Runnable {
                    adPacketGetDialogView.canClick(false)
                    getDialog!!.closeDialog()
                })
            } else {
                getDialog!!.closeDialog()
            }
        }
        getDialog = cn.lejiayuan.Redesign.Dialog.Base.AnimationDialog(context, adPacketGetDialogView)
        getDialog!!.setPullStyle(cn.lejiayuan.Redesign.Dialog.Base.AnimationDialog.PullStyle.PULL_STYLE_FROM_CENTER)
        getDialog!!.setCanceledOnTouchOutside(true)
        getDialog!!.showDialog()
    }


    fun openRedPacket(context: Context, rpgId: String, runnable: Runnable) {
        dialogUtil = ProgressDialogUtil(context, resources.getString(R.string.topic_postcomment_01))
        dialogUtil!!.show()
        val httpOpenRedPacketRsqBean = HttpOpenRedPacketRsqBean()
        httpOpenRedPacketRsqBean.id = rpgId
//        httpOpenRedPacketRsqBean.userOpenId = SharedPreferencesUtil.getInstance(context).getuserId().toString() + ""

        TODO()
        JsonBeanRequestEngine.Builder(context,"", HttpOpenRedPacketRspBean::class.java)
//        JsonBeanRequestEngine.Builder(context, httpOpenRedPacketRsqBean.url, HttpOpenRedPacketRspBean::class.java)
                .create().asyncRequest(object : IJsonBeanListenerImpl<HttpOpenRedPacketRspBean>(context) {

            override fun onError(error: VolleyError) {
                runnable.run()
                if (dialogUtil != null && dialogUtil!!.isShowing()) {
                    dialogUtil!!.dismiss()
                }
                if (error.apiErrorCode == "400000003") {
                    ShowUtil.showShortToast(context, resources.getString(R.string.topic_postcomment_02))
                    AnalysisEventUtil.redPacketOpenClick(context, "RedPackGetExpired", "", "")
                } else {
                    AnalysisEventUtil.redPacketOpenClick(context, "Others", "", "")
                    ShowUtil.showShortToast(context, resources.getString(R.string.topic_postcomment_03))
                }
            }

            override fun onResponse(response: HttpOpenRedPacketRspBean?) {
                runnable.run()
                if (dialogUtil != null && dialogUtil!!.isShowing()) {
                    dialogUtil!!.dismiss()
                }
                if (null != response) {
                    val intent = Intent(context, AdRedPacketDetailActivity::class.java)
                    intent.putExtra("httpOpenRedPacketRspBean", response)
                    intent.putExtra("redId", response.id)
                    context.startActivity(intent)
                    AnalysisEventUtil.redPacketOpenClick(context, "RedPackGetSuccess", response.id, response.type)
                }
            }
        })
    }

    private fun doInput() {
        //点击"评论内容"输入框
        RxView.clicks(tvInputView)
                .debounce(500, TimeUnit.MILLISECONDS)
                .compose(bindToLifecycle())
                .observeOn(AndroidSchedulers.mainThread())
                .filter {
                    if (!TextUtils.isEmpty(SharedPreferencesUtil.getInstance(this).token)) true else {
                        openActivity(LoginActivity::class.java)
                        false
                    }
                }
                .subscribe({
                    CommentFragment
                            .newInstance(ReplyReqModel(postModel?.userId!!, "comment",
                                    tempPostid, "", ""
                                    , SharedPreferencesUtil.getInstance(this).getuserId().toString())
                                    , CommentFragment.FromType.POST_DETAIL_COMMENT.name
                                    , 0
                                    , "")
                            .show(supportFragmentManager, "KinshipPicker")
                }, {})
    }

    private fun doShare() {
        RxView.clicks(ivShareBtn)
                .debounce(500, TimeUnit.MILLISECONDS)
                .compose(bindToLifecycle())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe({
                    var imageUrl = ""
                    if (postModel?.pageList != null && postModel?.pageList!!.isNotEmpty())
                        imageUrl = postModel?.pageList!![0].picUrl
                    ShareUtils.getShareUitls(this).startShare(Constance.SHARE_POST_DETAIL, getQueryId(), true)
//                    Share.getShare(this).createSharedialog("我发现个热闹事，还不来围观下。", "#${postModel?.title}#${postModel?.content}",
//                            if (imageUrl != "") imageUrl else "", null,
//                            R.mipmap.icon, "${Constance.URL_GET_POST_INFO_SHARE}postId=${postModel?.postId}")

                }, {})
    }

    private fun getQueryId(): String {
        return "&postId=" + postModel?.postId + "&nickName=" + postModel?.nickName + "&iconUrl=" + postModel?.iconUrl +
                "&content=" + postModel?.content + "&activityId=" + postModel?.activityId + "&likesNumber=" + postModel?.likesNumber +
                "&postTime=" + postModel?.postTime + "&communityId=" + postModel?.communityId + "&commentNumber=" + postModel?.commentNumber +
                "&title=" + postModel?.title + "&userId=" + postModel?.userId + "&postType=" + postModel?.postType +
                "&isDoLikes=" + postModel?.isDoLikes + "&communityName=" + postModel?.communityName
    }

    private fun doLike() {
//        RxView.clicks(flLikeBtn)
//                .debounce(500, TimeUnit.MILLISECONDS)
//                .compose(bindToLifecycle())
//                .observeOn(AndroidSchedulers.mainThread())
//                .filter {
//                    if (!TextUtils.isEmpty(SharedPreferencesUtil.getInstance(this).token)) true else {
//                        openActivity(LoginActivity::class.java)
//                        false
//                    }
//                }
//                .filter {
//                    ivLikeImg.startAnimation(likeAnim)
//                    //ivLikeImg.isEnabled
//                    true
//                }
//                .map {
//                    LikeReqModel(postModel?.postId!!, SharedPreferencesUtil
//                            .getInstance(this).getuserId().toString())
//                }
//                .flatMap { reqModel ->
//                    if("Yes".equals(postModel?.isDoLikes)){
//                        //取消点赞
//                        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//                                .mUnDoLike(reqModel, RequestUtil.getHeader(reqModel))
//                                .compose(RxSchedulersHelper.io_main()).toObservable()
//                    }else{
//                        //执行点赞
//                        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//                                .mDoLike(reqModel, RequestUtil.getHeader(reqModel))
//                                .compose(RxSchedulersHelper.io_main()).toObservable()
//                    }
//                }
//                .filter { req ->
//                    //ToastUtil.showShort(req.rspInf)
//                    HttpRspCd.SUCCESS == req.rspCd
//                }
//                .subscribe({ req ->
//                    tvLikeNum.text = req.likesNumber
//
//                    if("Yes".equals(postModel?.isDoLikes)){
//                        //取消点赞
//                        postModel?.isDoLikes = "No"
//                        ivLikeImg.setImageResource(R.mipmap.courenao_button_zan_gray)
//                    }else{
//                        //执行点赞
//                        ivLikeImg.setImageResource(R.mipmap.courenao_button_zan_orange)
//                        postModel?.isDoLikes = "Yes"
//                    }
//                    postModel?.likesNumber = req.likesNumber
//                    if (from != "") {
//                        RxBus.getInstance().post(PostRefreshEvent(from, index, postModel))
//                    }
//                }, { error ->
//                    ToastUtil.showShort(error.message)
//                })
    }

    override fun onDestroy() {
        PostCommentListActivity.MessageList.clear()
        super.onDestroy()
    }

}