package cn.lejiayuan.Redesign.Function.topic

import android.content.ClipData
import android.content.ClipboardManager
import android.content.Context
import android.content.Intent
import android.support.v7.widget.LinearLayoutManager
import android.text.TextUtils
import android.view.View
import android.widget.TextView
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Annotation.LAYOUT
import cn.lejiayuan.Redesign.Base.BaseActivity
import cn.lejiayuan.Redesign.Function.OldClass.login.LoginActivity
import cn.lejiayuan.Redesign.Function.topic.adapter.PostListAdapter
import cn.lejiayuan.Redesign.Function.topic.model.PostListModel
import cn.lejiayuan.Redesign.Function.topic.model.TopicListModel
import cn.lejiayuan.Redesign.Function.topic.model.req.PostListRequestModel
import cn.lejiayuan.Redesign.Function.topic.model.req.TopicDetailReqModel
import cn.lejiayuan.rxbus.RxBus
import cn.lejiayuan.rxbus.RXEvent.PostRefreshEvent
import cn.lejiayuan.rxbus.RXEvent.TopicModelRefreshEvent
import cn.lejiayuan.Redesign.View.LodingDialog
import cn.lejiayuan.Redesign.retrofit.ApiInterface
import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxRequestStatus
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.common.utils.ShareUtils
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import cn.lejiayuan.constance.Constance
import cn.lejiayuan.common.utils.ToastUtil
import com.isseiaoki.simplecropview.util.Logger
import com.jakewharton.rxbinding2.view.RxView
import com.ms.square.android.expandabletextview.ExpandableTextView
import io.reactivex.android.schedulers.AndroidSchedulers
import kotlinx.android.synthetic.main.activity_topic_main.*
import java.util.concurrent.TimeUnit

//话题详情
@LAYOUT(R.layout.activity_topic_main)
class PostListActivity : BaseActivity() {

    companion object {
        //通知评论数目+1
        val NOTIFY_COMMENT_NUMBER = "notify_comment_number"
        val FROM_HOME_PAGE_FRAGMENT = "HomePageFragment"
    }

    enum class PostFrom {
        HOME, LIST
    }

    enum class StaticValue {
        TOPIC_FROM,
        TOPIC_INDEX,
        TOPIC_INFO,
        TOPIC_EVENTID
    }

    var from = ""
    var index = 0

    val mAdapter: PostListAdapter = PostListAdapter()

    var topicInfo: TopicListModel? = TopicListModel()

    var eTv: ExpandableTextView? = null
    var expandView : View? = null
    var fromPage : String? = null
    var eventID : String? = ""
    var lodingDialog : LodingDialog?=null


    override fun layout() {

        val intent = intent
        val action = intent.action
        if (Intent.ACTION_VIEW == action) {
            val uri = intent.data
            topicInfo?.eventId = uri.getQueryParameter("eventId")
//            topicInfo?.readTotal = uri.getQueryParameter("readTotal")
//            topicInfo?.subject = uri.getQueryParameter("subject")
//            topicInfo?.content = uri.getQueryParameter("content")
//            topicInfo?.coverImgUrl = uri.getQueryParameter("coverImgUrl")
//            topicInfo?.summary = uri.getQueryParameter("summary")
//            topicInfo?.isLocalSee = uri.getQueryParameter("isLocalSee")
        }else{
            //必须要传递一个topicInfo对象或者eventID
            topicInfo = intent.getSerializableExtra(StaticValue.TOPIC_INFO.name) as TopicListModel?
            if (topicInfo != null){
                eventID = topicInfo?.eventId
            }else{
                eventID = intent.getStringExtra(StaticValue.TOPIC_EVENTID.name)?:""
            }
            from = intent.getStringExtra(StaticValue.TOPIC_FROM.name)?:""
            index = intent.getIntExtra(StaticValue.TOPIC_INDEX.name, 0)
            fromPage = intent.getStringExtra(FROM_HOME_PAGE_FRAGMENT)?:""
        }

        closeView.setOnClickListener {
            if (FROM_HOME_PAGE_FRAGMENT.equals(fromPage)){
                val itent = Intent(PostListActivity@this, TopicListsActivity::class.java)
                itent.putExtra(TopicListsActivity.SELECT_NUMBER_KEY, 1)
                startActivity(itent)
                finish()
            }else{
                finish()
            }
        }

        rvTopicMainList.layoutManager = LinearLayoutManager(this)

        rvTopicMainList.adapter = mAdapter

        mAdapter.setOnLoadMoreListener({ getPostList(false) }, rvTopicMainList)

        //这里才是真正的扩展的ExpandableTextView
        expandView = View.inflate(this, R.layout.view_expandable_text_view, null)
        eTv = expandView!!.findViewById(R.id.expand_text_view) as ExpandableTextView


        var mTextView = expandView!!.findViewById(R.id.expandable_text) as TextView
        mTextView.setOnLongClickListener{
            val mText = eTv!!.getText().toString()
            //获取剪贴板管理器：
            var clipManager = (this.getSystemService(Context.CLIPBOARD_SERVICE)) as ClipboardManager
            // 创建普通字符型ClipData
            var mClipData = ClipData.newPlainText("Label", mText) as ClipData
            // 将ClipData内容放到系统剪贴板里。
            clipManager.setPrimaryClip(mClipData)
            ToastUtil.showShort(resources.getString(R.string.topic_postcomment_05))
            false
        }

        mAdapter.addHeaderView(eTv)
        if (topicInfo != null){
            initTopData(this.topicInfo!!)
        }

        refreshView.setColorSchemeColors(resources.getColor(R.color.colorPrimary))

        refreshView.setOnRefreshListener {
            mAdapter.setEnableLoadMore(true)
            getPostList(true)
        }

        //
        lodingDialog = LodingDialog(this)
        lodingDialog!!.show()

        getPostList(false)
        getTopicDetail()

        RxView.clicks(btTopicMainNewTopic)
                .compose(bindToLifecycle())
                .debounce(500, TimeUnit.MILLISECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .filter {
                    if (!TextUtils.isEmpty(SharedPreferencesUtil.getInstance(this).token)) true else {
                        openActivity(LoginActivity::class.java)
                        false
                    }
                }
                .subscribe({
                    val intent = Intent(this@PostListActivity, NewTopicActivity::class.java)
                    intent.putExtra(NewTopicActivity.ACTIVITY_ID, eventID)
                    intent.putExtra(NewTopicActivity.TITLE, toolbar_layout.title.toString())
                    startActivity(intent)
                }, {
                    error->
                    Logger.e(error.message)
                })

        RxBus.getInstance().toObservable(PostListModel::class.java)
                .compose(bindToLifecycle())
                .subscribe { model -> mAdapter.addData(0, model) }

        RxBus.getInstance().toObservable(PostRefreshEvent::class.java)
                .compose(bindToLifecycle())
                .filter { b -> TextUtils.equals(PostCommentListActivity.FromType.LIST.name, b.fromType) }
                .subscribe({ model ->
                    mAdapter.setData(model.fromIndex - mAdapter.headerLayoutCount, model.postModel!!)
                }, {})

        //刷新评论数目
        RxBus.getInstance().toObservable(PostRefreshEvent::class.java)
                .compose(bindToLifecycle())
                .subscribe({ model ->
                    if (TextUtils.equals(NOTIFY_COMMENT_NUMBER, model.fromType)){
                        mAdapter.setData(model.fromIndex - mAdapter.headerLayoutCount, model.postModel!!)
                    }
                }, {})


        RxView.clicks(flShare)
                .compose(bindToLifecycle())
                .debounce(500, TimeUnit.MILLISECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe({
                    ShareUtils.getShareUitls(this).startShare(Constance.SHARE_TOPIC_DETAIL,getQueryId(),true)
//                    Share.getShare(this).createSharedialog("我发现了不错的热闹话题#${topicInfo?.subject}#", topicInfo?.summary,
//                            topicInfo?.coverImgUrl, null,
//                            R.mipmap.icon, "${Constance.URL_GET_TOPIC_INFO_SHARE}eventId=${topicInfo?.eventId}")
                }, {})

        super.layout()
    }

    private fun getQueryId():String{
        return "&eventId="+topicInfo?.eventId+"&readTotal="+topicInfo?.readTotal+"&subject="+topicInfo?.subject+
                "&content="+topicInfo?.content+"&coverImgUrl="+
                topicInfo?.coverImgUrl+"&summary="+topicInfo?.summary+"&isLocalSee="+topicInfo?.isLocalSee
//        +"&topicId="+topicInfo?.
    }
    private fun initTopData(topicInfo: TopicListModel) {
        sdvTopicTopImage.setImageURI(topicInfo.coverImgUrl)

        //http://blog.csdn.net/zhyh1986/article/details/52220907
        //如果结合 CollapsingToolbarLayout 和 Toolbar 一起使用,这时我们需要调用 CollapsingToolbarLayout 的 setTitle() 方法：
        toolbar_layout.title = topicInfo.subject

        tvRankingTopText.text = topicInfo.readTotal

        mAdapter.topicInfo = topicInfo
        eTv?.text = topicInfo.content
    }

    //主要增加阅读量
    private fun getTopicDetail() {
        val req = TopicDetailReqModel(eventID!!)
//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//            .mGetTopicDetail(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .map { result ->
//                    {
//                        result.getTopicListModel()
//                    }
//                }
//                .subscribe({ model ->
//                    if(lodingDialog!=null&&lodingDialog!!.isShowing){
//                        lodingDialog!!.dismiss()
//                    }
//                    initTopData(model.invoke())
//                    if (from != "")
//                        RxBus.getInstance().post(TopicModelRefreshEvent(from, index, model.invoke()))
//                }, {
//
//                    if(lodingDialog!=null&&lodingDialog!!.isShowing){
//                        lodingDialog!!.dismiss()
//                    }
//                })
    }


    //获取当前话题下帖子列表
    private fun getPostList(isRefresh: Boolean) {
        val req = PostListRequestModel()
        req.doLikesUserId = SharedPreferencesUtil.getInstance(this).getuserId().toString()
        req.activityId = eventID!!
        req.postId = if (!isRefresh && mAdapter.data.size > 0) mAdapter.data[mAdapter.data.size - 1].postId else "0"
        req.communityId = if ("Yes" == topicInfo?.isLocalSee) SharedPreferencesUtil.getInstance(this).areaId.toString() else ""
//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//            .mGetPostList(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .map { list ->
//                    {
//                        refreshView.isRefreshing = false
//                        list.postList
//                    }
//                }
//                .filter { list ->
//                    if (list.invoke() == null || (list.invoke() != null && list.invoke()!!.isEmpty()))
//                        mAdapter.loadMoreEnd()
//                    list.invoke()?.size!! > 0
//                }
//                .subscribe({ list ->
//                    if(lodingDialog!=null&&lodingDialog!!.isShowing){
//                        lodingDialog!!.dismiss()
//                    }
//                    mAdapter.loadMoreComplete()
//                    if (isRefresh){
//                        mAdapter.setNewData(list.invoke())
//                    }
//                    else{
//                        mAdapter.addData(list.invoke()!!)
//                    }
//
//
//
//                }, { error ->
//                    if(lodingDialog!=null&&lodingDialog!!.isShowing){
//                        lodingDialog!!.dismiss()
//                    }
//                    mAdapter.loadMoreFail()
//                    refreshView.isRefreshing = false
//                    showShortToast(error.message)
//                })

    }
}
