package cn.lejiayuan.Redesign.Function.topic

import android.support.v4.widget.SwipeRefreshLayout
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Base.BaseFragment
import cn.lejiayuan.Redesign.Function.topic.adapter.PostReplyAdapter
import cn.lejiayuan.Redesign.Function.topic.model.req.ReplyMeReqModel
import cn.lejiayuan.Redesign.retrofit.ApiInterface
import cn.lejiayuan.rxbus.RxBus
import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxRequestStatus
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.common.utils.SharedPreferencesUtil

/**
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/22
 * Time: 下午4:44
 */
class ReplyListFragment : BaseFragment() {

    companion object {
        val notifyRefreshList = "notifyRefreshList"
    }

    val mAdapter = PostReplyAdapter()
    var refreshView: SwipeRefreshLayout? = null
    override fun layout(inflater: LayoutInflater?): View {
        refreshView = SwipeRefreshLayout(this.context!!)
        val list = RecyclerView(MyTopicFragment@ this.context!!)
        list.layoutManager = LinearLayoutManager(MyTopicFragment@ this.context!!)
        mAdapter.supportFragmentManager = activity!!.supportFragmentManager
        list.adapter = mAdapter
        getReplyMeList(true)
        refreshView?.addView(list)
        refreshView?.setColorSchemeColors(resources.getColor(R.color.colorPrimary))
        refreshView?.setOnRefreshListener {
            getReplyMeList(true)
        }

        mAdapter.setOnLoadMoreListener({ getReplyMeList(false) }, list)

        //接收刷新数据
        recvRxData()

        return refreshView as SwipeRefreshLayout
    }


    private fun recvRxData() {
        RxBus.getInstance().toObservable(String::class.java)
                .compose(bindToLifecycle())
                .subscribe({
                    str->
                    if (str.equals(ReplyListFragment.notifyRefreshList)){
                        //刷新列表
                        getReplyMeList(true)
                    }
                },{
                    onError->
                })

    }

    private fun getReplyMeList(isRefresh: Boolean) {
        val req = ReplyMeReqModel()
        req.commentId = if (!isRefresh && mAdapter.data.size > 0) mAdapter.data[mAdapter.data.size - 1].commentId else "0"
        req.userId = SharedPreferencesUtil.getInstance(context).getuserId().toString()

//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//            .mGetReplyMeList(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .map { list ->
//                    {
//                        refreshView?.isRefreshing = false
//                        list.myReplyDtoList
//                    }
//                }
//                .filter { list ->
//                    if (list.invoke() == null || (list.invoke() != null && list.invoke()!!.isEmpty()))
//                        mAdapter.loadMoreEnd()
//                    list.invoke()?.size!! > 0
//                }
//                .subscribe({ list ->
//                    mAdapter.loadMoreComplete()
//                    if (isRefresh) {
//                        mAdapter.setNewData(list.invoke())
//                    } else {
//                        mAdapter.addData(list.invoke()!!)
//                    }
//                }, { error ->
//                    mAdapter.loadMoreFail()
//                    refreshView?.isRefreshing = false
//                    showShortToast(error.message)
//                })
    }
}