package cn.lejiayuan.Redesign.Function.topic

import android.os.Bundle
import android.support.design.widget.TabLayout
import android.support.v4.app.Fragment
import android.support.v4.app.FragmentManager
import android.support.v4.app.FragmentPagerAdapter
import android.support.v4.view.ViewPager
import android.view.LayoutInflater
import android.view.View
import android.widget.TextView
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Base.BaseFragment
import java.util.ArrayList
import kotlinx.android.synthetic.main.fragment_topic_table_me.*

/**
 * Table: 我的
 */
class TopicTableMeFragment : BaseFragment() {

  private var adapter: TopicTableMeFragment.ViewPagerAdapter? = null
  private var tab1: TabLayout.Tab? = null
  private var tab2: TabLayout.Tab? = null

  private var view1: View? = null
  private var view2: View? = null

  public var mTextView1: TextView? = null
  public var mTextView2: TextView? = null

  override fun layout(inflater: LayoutInflater?): View {

    val layoutView = inflater!!.inflate(R.layout.fragment_topic_table_me, null)

    return layoutView
  }

  override fun onViewCreated(
    view: View,
    savedInstanceState: Bundle?
  ) {
    super.onViewCreated(view, savedInstanceState)
    setupViewPager()
  }

  private fun setupViewPager() {
    incView.setVisibility(View.GONE)

    setupViewPager(viewPager)
    channelTabLayout.setupWithViewPager(viewPager)

    //自定义View
    val titleList: ArrayList<String> = adapter!!.getTitleList()
    setUpTabBadge(titleList)

  }

  private fun setupViewPager(viewPager: ViewPager) {
    adapter = ViewPagerAdapter(childFragmentManager)

    val rankingByDay = ReplyListFragment()
    val dayBundle = Bundle()
    rankingByDay.arguments = dayBundle

    val rankingByWeek = MyTopicFragment()
    val weekBundle = Bundle()
    rankingByWeek.arguments = weekBundle

    //回复我的、我发布的
    (adapter as TopicTableMeFragment.ViewPagerAdapter).addFrag(
        rankingByDay, getString(R.string.topic_table_me_replay)
    )
    (adapter as TopicTableMeFragment.ViewPagerAdapter).addFrag(
        rankingByWeek, getString(R.string.topic_table_me_publish)
    )

    viewPager.adapter = adapter
    viewPager.offscreenPageLimit = 5

    val pageChangeListener = TabOnPageChangeListener()
    viewPager.addOnPageChangeListener(pageChangeListener)
  }

  /**
   * 自定义TabLayout View
   */
  private fun setUpTabBadge(mTitles: ArrayList<String>) {
    tab1 = channelTabLayout.getTabAt(0)
    if (tab1 != null) {
      view1 = LayoutInflater.from(this.activity)
          .inflate(R.layout.topic_my_tab_title_layout, null)
      mTextView1 = ((view1 as View).findViewById(R.id.tv_title) as TextView)
      mTextView1!!.setText(mTitles.get(0))
      tab1!!.setCustomView(view1)
    }

    tab2 = channelTabLayout.getTabAt(1)
    if (tab2 != null) {
      view2 = LayoutInflater.from(this.activity)
          .inflate(R.layout.topic_my_tab_title_layout, null)
      mTextView2 = ((view2 as View).findViewById(R.id.tv_title) as TextView)
      mTextView2!!.setText(mTitles.get(1))
      tab2!!.setCustomView(view2)
    }
  }

  internal class ViewPagerAdapter(manager: FragmentManager) : FragmentPagerAdapter(manager) {

    private val mFragmentList = ArrayList<Fragment>()
    private val mFragmentTitleList = ArrayList<String>()

    override fun getItem(position: Int): Fragment = mFragmentList[position]

    override fun getCount(): Int = mFragmentList.size

    fun addFrag(
      fragment: Fragment,
      title: String
    ) {
      mFragmentList.add(fragment)
      mFragmentTitleList.add(title)
    }

    override fun getPageTitle(position: Int): CharSequence = mFragmentTitleList[position]

    fun getTitleList(): ArrayList<String> {
      return mFragmentTitleList
    }
  }

  //内部类
  inner class TabOnPageChangeListener : ViewPager.OnPageChangeListener {

    override fun onPageSelected(position: Int) {
      when (position) {
        0 -> {
          mTextView1!!.setBackgroundResource(R.drawable.shap_topic_my_publish)
          mTextView2!!.setBackgroundResource(R.drawable.shap_topic_my_publish_unenable)
        }

        1 -> {
          mTextView1!!.setBackgroundResource(R.drawable.shap_topic_my_publish_unenable)
          mTextView2!!.setBackgroundResource(R.drawable.shap_topic_my_publish)
        }
      }
    }

    override fun onPageScrolled(
      position: Int,
      positionOffset: Float,
      positionOffsetPixels: Int
    ) {
    }

    override fun onPageScrollStateChanged(state: Int) {

    }
  }
}