package cn.lejiayuan.Redesign.Function.topic

import android.support.v4.widget.SwipeRefreshLayout
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Base.BaseFragment
import cn.lejiayuan.Redesign.Function.topic.adapter.MyPostAdapter
import cn.lejiayuan.Redesign.Function.topic.model.req.LatestTopicReqModel
import cn.lejiayuan.rxbus.RxBus
import cn.lejiayuan.rxbus.RXEvent.PostRefreshEvent
import cn.lejiayuan.rxbus.RXEvent.TopicModelRefreshEvent
import cn.lejiayuan.Redesign.View.LodingDialog
import cn.lejiayuan.Redesign.retrofit.ApiInterface
import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxRequestStatus
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.common.utils.SharedPreferencesUtil

/**
 * Table: 最新
 * 和 MyTopicFragment 很像
 */

//显示红点
//const val SHOW_RED_NODE : String = "show"
var lodingDialog : LodingDialog?=null

class TopicTableNewFragment : BaseFragment() {
    var refreshView: SwipeRefreshLayout? = null
    var boolNotifyTabSubject:Boolean = true
    val mAdapter = MyPostAdapter()

    override fun layout(inflater: LayoutInflater?): View {

        val list = RecyclerView(this.context!!)
        refreshView = SwipeRefreshLayout(this.context!!)
        list.layoutManager = LinearLayoutManager(this.context!!)

        //不显示删除按钮
        mAdapter.setShowDelButton(false)
        list.adapter = mAdapter



        getPostList(true)
        refreshView?.addView(list)
        refreshView?.setColorSchemeColors(resources.getColor(R.color.colorPrimary))
        refreshView?.setOnRefreshListener {
            getPostList(true)
        }

        mAdapter.setOnLoadMoreListener({ getPostList(false) }, list)

        RxBus.getInstance().toObservable(PostRefreshEvent::class.java)
                .compose(bindToLifecycle())
                .filter { b -> TextUtils.equals(PostCommentListActivity.FromType.ME.name, b.fromType) }
                .filter { b -> mAdapter.data[b.fromIndex] != null }
                .subscribe({ model ->
                    model.fromIndex
                    mAdapter.data[model.fromIndex] = model.postModel
                    mAdapter.notifyItemChanged(model.fromIndex)
                }, {})
        return refreshView as SwipeRefreshLayout
    }


    private fun getPostList(isRefresh: Boolean) {

        val req = LatestTopicReqModel()

        req.doLikesUserId = SharedPreferencesUtil.getInstance(context).getuserId().toString()
        req.postId = if (!isRefresh && mAdapter.data.size > 0) mAdapter.data[mAdapter.data.size - 1].postId else "0"
        req.communityId = SharedPreferencesUtil.getInstance(context).areaId.toString()
        req.firstPostId = if (!isRefresh && mAdapter.data.size > 0) mAdapter.data[0].postId else "0"

//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java).mGetTableNewPostList(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .map { list ->
//                    {
//                        refreshView?.isRefreshing = false
//                        if (list.postNewCount > 0){
//                            //显示"最新"红点
//                            RxBus.getInstance().post(TopicListsActivity.TOPIC_TAB_NEW_RED_DOT_SHOW)
//                        }else{
//                            RxBus.getInstance().post(TopicListsActivity.TOPIC_TAB_NEW_RED_DOT_HIDE)
//                        }
//                        list.postList
//                    }
//                }
//                .filter { list ->
//                    if (list.invoke() == null || (list.invoke() != null && list.invoke()!!.isEmpty()))
//                        mAdapter.loadMoreEnd()
//                    list.invoke()?.size!! > 0
//                }
//                .subscribe({ list ->
//
//                    mAdapter.loadMoreComplete()
//                    if (isRefresh) {
//                        mAdapter.setNewData(list.invoke())
//                    } else {
//                        mAdapter.addData(list.invoke()!!)
//                    }
//                    //通知"话题"页面加载数据(主要是"话题"页面需要firstPostID)
//                    if (boolNotifyTabSubject){
//                        boolNotifyTabSubject = false
//                        RxBus.getInstance().post(TopicModelRefreshEvent(getFistPostId()))
//                    }
//                }, { error ->
//
//                    mAdapter.loadMoreFail()
//                    refreshView?.isRefreshing = false
//                    showShortToast(error.message)
//                })

    }

    public fun getFistPostId() : String{
        var tempId:String
        if (mAdapter!=null && mAdapter.data.size>0){
            tempId = mAdapter.data[0].postId
        }else{
            tempId = "0"
        }
        return tempId
    }
}