package cn.lejiayuan.Redesign.Function.topic

import android.content.Intent
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.text.Html
import android.text.TextUtils
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Base.BaseFragment
import cn.lejiayuan.Redesign.Function.OldClass.login.LoginActivity
import cn.lejiayuan.Redesign.Function.topic.adapter.TopicListAdapter
import cn.lejiayuan.Redesign.Function.topic.model.req.ReplyMeCountReqModel
import cn.lejiayuan.Redesign.Function.topic.model.req.TopicListRequestModel
import cn.lejiayuan.Redesign.Function.topic.widget.TopicSubjectLoadMoreView
import cn.lejiayuan.Redesign.retrofit.ApiInterface
import cn.lejiayuan.rxbus.RxBus
import cn.lejiayuan.rxbus.RXEvent.TopicModelRefreshEvent
import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxRequestStatus
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import cn.lejiayuan.common.utils.DisPatchDataUtil
import com.jakewharton.rxbinding2.view.RxView
import io.reactivex.android.schedulers.AndroidSchedulers
import java.util.concurrent.TimeUnit
import kotlinx.android.synthetic.main.activity_topic_list_by_kotlin.*

/**
 * Table: 话题
 */


class TopicTableSubjectFragment : BaseFragment() {
    private var curPageSize = 0
    private var tempFirstPostId : String = ""


    private val topicAdapter = TopicListAdapter()

    override fun layout(inflater: LayoutInflater?): View {

        val layoutView = inflater!!.inflate(R.layout.activity_topic_list_by_kotlin, null)

        return layoutView
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        view_include_toolbar.setVisibility(View.GONE)

        //设置加载更多视图
        val loadMoreView = TopicSubjectLoadMoreView()
        topicAdapter.setLoadMoreView(loadMoreView)

        rvTopicList.layoutManager = LinearLayoutManager(this.activity)
        rvTopicList.adapter = topicAdapter

        RxView.clicks(tvTopicListNews)
                .debounce(500, TimeUnit.MILLISECONDS)
                .compose(bindToLifecycle())
                .observeOn(AndroidSchedulers.mainThread())
                .filter {
                    if (!TextUtils.isEmpty(SharedPreferencesUtil.getInstance(this.activity).token)) true else {
                        val intent = Intent(this.activity, LoginActivity::class.java)
                        startActivity(intent)
                        false
                    }
                }
                .subscribe({
                    tvTopicListNews.visibility = View.GONE
                    //"跳转"我的" TAB "
                    RxBus.getInstance().post(TopicListsActivity.SKIP_ME_TABLE)
                    //隐藏"我的"TAB红点
                    RxBus.getInstance().post(TopicListsActivity.NOTIFY_TOPIC_TAB_ME_RED_DOT_HIDE)
                }, {})


        topicAdapter.setOnLoadMoreListener({
            if (curPageSize<10){
                topicAdapter.loadMoreComplete()
                topicAdapter.loadMoreEnd()
            }else{
                getTopicList(false)
            }
        }, rvTopicList)


        refreshView.setColorSchemeColors(resources.getColor(R.color.colorPrimary))

        refreshView.setOnRefreshListener {
            topicAdapter.setEnableLoadMore(true)
            getTopicList(true)
            getReplyMeContent()
        }


        getReplyMeContent()

        recvLoadTopicList()

        RxBus.getInstance()
                .toObservable(TopicModelRefreshEvent::class.java)
                .compose(bindToLifecycle())
                .filter { b -> TextUtils.equals(PostListActivity.PostFrom.LIST.name, b.fromType) }
                .subscribe({ topicModelRefreshEvent ->
                    topicAdapter.data[topicModelRefreshEvent.fromIndex] = topicModelRefreshEvent.topicModel
                    topicAdapter.notifyItemChanged(topicModelRefreshEvent.fromIndex)
                }, {})
    }

    /**
     * 加载"话题"数据(最新页面通知过来)
     */
    private fun recvLoadTopicList() {
        RxBus.getInstance().toObservable(TopicModelRefreshEvent::class.java)
                .compose(bindToLifecycle())
                .subscribe({ event ->
                    tempFirstPostId = event.mFirstPostID
                    getTopicList(true)
                }, { onError ->
                })
    }


    private fun getReplyMeContent() {

        val req = ReplyMeCountReqModel()
        req.userId = SharedPreferencesUtil.getInstance(this.activity).getuserId().toString()

        Log.i("fyg","userId:"+ req.userId );

//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//            .mGetReplyMeCount(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .map { result ->
//                    result.amount
//                }
//                .subscribe({ amount ->
//
//                    tvTopicListNews.text = Html.fromHtml("您有 <font color='#FF6C00'>$amount</font> 条新的回复")
//                    if (amount.toInt() > 0){
//                        tvTopicListNews.visibility = View.VISIBLE
//                        //"我的"TAB 显示红点
//                        RxBus.getInstance().post(TopicListsActivity.NOTIFY_TOPIC_TAB_ME_RED_DOT_SHOW)
//                    }else{
//                        tvTopicListNews.visibility = View.GONE
//                        //隐藏"我的"TAB红点
//                        RxBus.getInstance().post(TopicListsActivity.NOTIFY_TOPIC_TAB_ME_RED_DOT_HIDE)
//                    }
//                }, {
//
//                })
    }

    private fun getTopicList(isRefresh: Boolean) {

        val req = TopicListRequestModel()
        req.eventId = if (!isRefresh && topicAdapter.data.size > 0)
            topicAdapter.data[topicAdapter.data.size - 1]?.eventId!! else "0"
        req.communityId = SharedPreferencesUtil.getInstance(this.activity).areaId.toString()
        req.firstPostId = tempFirstPostId

//        BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//            .mGetTopicList(req, RequestUtil.getHeader(req))
//                .compose(bindToLifecycle())
//                .compose(RxSchedulersHelper.io_main())
//                .compose(RxRequestStatus.checkStatus())
//                .map { topicListResponseModel ->
//                    {
//                        refreshView.isRefreshing = false
//                        if (topicListResponseModel.postNewCount>0){
//                            //通知最新红点
//                            RxBus.getInstance().post(TopicListsActivity.TOPIC_TAB_NEW_RED_DOT_SHOW)
//                        }else{
//                            RxBus.getInstance().post(TopicListsActivity.TOPIC_TAB_NEW_RED_DOT_HIDE)
//                        }
//                        topicListResponseModel.activityList
//
//                    }
//                }
//                .filter { list ->
//                    if (list.invoke() == null || (list.invoke() != null && list.invoke()!!.isEmpty()))
//                        topicAdapter.loadMoreEnd()
//                    list.invoke()?.size!! > 0
//                }
//                .subscribe({ list ->
//                    topicAdapter.loadMoreComplete()
//                    curPageSize =  list.invoke()!!.size
//                    if (isRefresh) {
//                        topicAdapter.setNewData(list.invoke())
////                        topicAdapter.replaceData(list.invoke()!!)
//                    } else{
//                        topicAdapter.addData(list.invoke()!!)
//                    }
//
//                    DisPatchDataUtil.getInstance().sendData(list.invoke())
//
//                }, { error ->
//                    topicAdapter.loadMoreFail()
//                    refreshView.isRefreshing = false
//                    showShortToast(error.message)
//                })
    }


}