package cn.lejiayuan.Redesign.Function.topic.adapter

import android.content.Context
import android.content.Intent
import android.graphics.drawable.BitmapDrawable
import android.graphics.drawable.Drawable
import android.text.Html
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.WindowManager
import android.view.animation.Animation
import android.view.animation.AnimationUtils
import android.widget.PopupWindow
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Function.Commodity.UI.HomePage.HomeLifeTopicItem
import cn.lejiayuan.Redesign.Function.topic.ImageGalleryActivity
import cn.lejiayuan.Redesign.Function.topic.PostCommentListActivity
import cn.lejiayuan.Redesign.Function.topic.PostListActivity
import cn.lejiayuan.Redesign.Function.topic.ReplyListFragment
import cn.lejiayuan.Redesign.Function.topic.model.PostListModel
import cn.lejiayuan.Redesign.Function.topic.model.req.LikeReqModel
import cn.lejiayuan.Redesign.Function.topic.model.req.TopicDELReqModel
import cn.lejiayuan.Redesign.Http.Common.HttpRspCd
import cn.lejiayuan.Redesign.View.AnimationDialog
import cn.lejiayuan.Redesign.View.BaseDialogFactory
import cn.lejiayuan.Redesign.retrofit.*
import cn.lejiayuan.activity.forum.ForumDetailActivity
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.bean.PhotoInfo
import cn.lejiayuan.bean.forum.requestBean.UpdateLikeReq
import cn.lejiayuan.bean.forum.responseBean.ForumListBean
import cn.lejiayuan.bean.forum.responseBean.ForumListNewBean
import cn.lejiayuan.bean.forum.rxbus.EventAddForum
import cn.lejiayuan.common.utils.*
import cn.lejiayuan.constance.Constance
import cn.lejiayuan.rxbus.RxBus
import com.beijing.ljy.frame.util.MathUtil
import com.beijing.ljy.frame.util.TimeUtil
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.jakewharton.rxbinding2.view.RxView
import io.reactivex.android.schedulers.AndroidSchedulers
import kotlinx.android.synthetic.main.item_ijoined_publish_layout.view.*
import kotlinx.android.synthetic.main.view_publish_item_bottom.view.*
import kotlinx.android.synthetic.main.view_topic_item_bottom.view.*
import java.util.concurrent.TimeUnit

/**
 * Created by liushuo on 18/3/16.
 */
class IPublishedFragmentAdapter : BaseQuickAdapter<ForumListNewBean, IPublishedFragmentAdapter.ViewHolder> {

    private var cancleAnimationDialog: AnimationDialog? = null
    //默认不显示删除按钮
    private var isShowDelButton: Boolean = false

    public var itemListener: OnPopWindowItemClickListener? = null

    constructor(layoutResId: Int) : super(layoutResId)

    constructor() : this(R.layout.item_ijoined_publish_layout)

    interface OnPopWindowItemClickListener {
        fun onPopClickListener(view: View, item: ForumListNewBean, position:Int)
    }

    fun setOnPopWindowItemClickListener(listener: OnPopWindowItemClickListener) {
        itemListener = listener
    };


    override fun convert(helper: IPublishedFragmentAdapter.ViewHolder, item: ForumListNewBean) {
        helper.bindData(item)
    }

    public fun setShowDelButton(bol : Boolean){
        isShowDelButton = bol;
    }

    inner class ViewHolder(itemView: View) : BaseViewHolder(itemView) {
        var context: Context? = null
        var likeAnim: Animation? = null

        var likeDrawable: Drawable? = null
        var unLikeDrawable: Drawable? = null

        var commentDrawable: Drawable? = null
        var shareDrawable: Drawable? = null
        var delDrawable: Drawable? = null

        init {
            context = itemView.context
            likeDrawable = context?.resources?.getDrawable(R.mipmap.pub_courenao_icon_zan_orange)
            likeDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))
            unLikeDrawable = context?.resources?.getDrawable(R.mipmap.pub_courenao_icon_zan_gray)
            unLikeDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            commentDrawable = context?.resources?.getDrawable(R.mipmap.pub_courenao_icon_pinglun)
            commentDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            shareDrawable = context?.resources?.getDrawable(R.mipmap.pub_courenao_icon_fenxiang)
            shareDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            delDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_del)
            delDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            likeAnim = AnimationUtils.loadAnimation(context, R.anim.like_anim)
        }

        fun bindData(topic: ForumListNewBean) {
            with(topic) {
                if ("YES".equals(topic.getIsAnonymous())){
                    itemView.tv_category.setText(R.string.mypublish_type_02)
                }else{
                    if (ConstantUtils.MyPublishType.CRN_TYPE.equals(topic.postType)){
                        itemView.tv_category.setText(R.string.mypublish_type_01)
                        itemView.tv_category.setTextColor(itemView.resources.getColor(R.color.color_ijoined_001))
                    }else if (ConstantUtils.MyPublishType.LT_TYPE.equals(topic.postType)){
                        itemView.tv_category.setText(R.string.mypublish_type_02)
                        itemView.tv_category.setTextColor(itemView.resources.getColor(R.color.color_ijoined_004))
                    }
                }

                itemView.tvDate.text = TimeUtil.getTimeString(topic.createTime.toLong())
                itemView.tvTopic.text = "#${topic.title}#"
                itemView.tvTopic.visibility = View.VISIBLE
                //itemView.tvTopicContent.text = topic.content

                itemView.tvTopicContent.text =
                        Html.fromHtml("<font color='#595959'>${topic.content}</font>")


                itemView.expandable_text.setOnClickListener {
                    //itemView.performClick()
                    //跳转到话题详情页面
//                    val intent = Intent(itemView.context, PostListActivity::class.java)
//                    intent.putExtra(PostListActivity.StaticValue.TOPIC_EVENTID.name, topic.activityId)
//                    itemView.context.startActivity(intent)

                }

                if (topic.picList != null && topic.picList!!.isNotEmpty()){
                    val photoInfoList = ArrayList<PhotoInfo>()
                    for (ss in topic.picList) {
                        val info = PhotoInfo()
                        info.setPicUrl(ss)
                        photoInfoList.add(info)
                    }
                    itemView.gvlTopicImages.setList(photoInfoList)
                }
                itemView.gvlTopicImages.visibility = if (topic.picList != null && topic.picList!!.isNotEmpty()) View.VISIBLE else View.GONE
                itemView.gvlTopicImages.setOnItemClickListener { _, position ->
                    run {
                        val intent = Intent(itemView.context, ImageGalleryActivity::class.java)
                        intent.putExtra(ImageGalleryActivity.IMAGE_GALLERY_INDEX, position)
                        intent.putParcelableArrayListExtra(ImageGalleryActivity.IMAGE_GALLERY_IMAGES_INFO, itemView.gvlTopicImages.list as ArrayList)
                        itemView.context.startActivity(intent)
                    }
                }

                //金豆
                if ("0".equals(topic.totalBeansAmount)){
                    itemView.tvjindou.text = itemView.resources.getString(R.string.forum_detail_04)
                }else{
                    itemView.tvjindou.text = topic.totalBeansAmount
                }

                if ("0".equals(topic.likesNumber)){
                    itemView.tvLikeBtn_publish.text = itemView.resources.getString(R.string.home_activity_ijoinedpost_08)
                }else{
                    itemView.tvLikeBtn_publish.text = topic.likesNumber
                }
                itemView.tvLikeBtn_publish.setCompoundDrawables(if ("NO".equals(topic.isDoLikes)) unLikeDrawable else likeDrawable, null, null, null)

                itemView.tvCommentBtn_publish.text = if (TextUtils.isEmpty(topic.commentNumber) || topic.commentNumber == "0") "评论" else topic.commentNumber

                //itemView.tvShareBtn.setCompoundDrawables(shareDrawable, null, null, null)
                //itemView.tvDelBtn.setCompoundDrawables(delDrawable, null, null, null)
                //itemView.flayout_del.setVisibility(if(isShowDelButton) View.VISIBLE else View.GONE)

                itemView.setOnClickListener {
                    //帖子详情
                    val intent = Intent(itemView.context, ForumDetailActivity::class.java)
                    intent.putExtra(ForumDetailActivity.POST_ID, topic.getPostId())
                    intent.putExtra(ForumDetailActivity.USER_ID, topic.getUserId())
                    intent.putExtra(ForumDetailActivity.POST_INFO, topic)
                    intent.putExtra(ForumDetailActivity.FORM_INDEX, adapterPosition)
                    itemView.context.startActivity(intent)
                }

                RxView.clicks(itemView.tvLikeBtn_publish)//点赞的点击事件
                        .debounce(500, TimeUnit.MILLISECONDS) //防止抖动点击 500毫秒内 只能点击一次
                        .observeOn(AndroidSchedulers.mainThread()) // 点击放在主线程执行
                        .filter {
                            //过滤器 先执行点击动画 然后判断是否要进行网络请求。
                            itemView.tvLikeBtn_publish.startAnimation(likeAnim)
                            //itemView.tvLikeBtn_publish.isEnabled
                            true
                        }
                        .map {
                            //初始化请求参数
                            UpdateLikeReq(topic.postId,topic.userType,"")
                        }
                        .flatMap { reqModel ->
                            if("YES".equals(topic.isDoLikes)){
                                //取消点赞
                                reqModel.setLikesSts("NO")
                                BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
                                        .postUnLike(reqModel)
                                        .compose(RxSchedulersHelper.io_main()).toObservable()
                            }else{
                                //执行点赞请求
                                reqModel.setLikesSts("YES")
                                BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
                                        .postLike(reqModel)
                                        .compose(RxSchedulersHelper.io_main()).toObservable()
                            }
                        }
                        .filter { req ->
                            //请求过滤 成功与否都输出请求结果 如果请求失败不继续执行
                            req.isSuccess
                        }
                        .subscribe({ req ->
                            //点赞请求成功 更新点赞个数 设置按钮状态 更新adapter数据
                            itemView.tvLikeBtn_publish.text = req.data
                            if("YES".equals(topic.isDoLikes)){
                                //取消点赞
                                topic.isDoLikes = "NO"
                                itemView.tvLikeBtn_publish.setCompoundDrawables(unLikeDrawable, null, null, null)
                            }else{
                                //执行点赞
                                itemView.tvLikeBtn_publish.setCompoundDrawables(likeDrawable, null, null, null)
                                topic.isDoLikes = "YES"
                            }
                            topic.likesNumber = req.data
                            data[adapterPosition - headerLayoutCount] = topic
                            notifyItemChanged(adapterPosition)
                        }, { error ->
                            ToastUtil.showShort(error.message)
                        })


                itemView.flayout_more.setOnClickListener {
                    if (itemListener!=null){
                        itemListener!!.onPopClickListener(itemView, topic, adapterPosition);
                    }
                }
            }
        }

        private fun httpReqTopicDel(topic: ForumListNewBean) {
            //初始请求参数
            BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
                    .getDeleteForum(topic.postId)
                    .compose(RxSchedulersHelper.io_main())
                    .compose(RxRequestStatus.checkStatus())
                    .subscribe({ postDelResp ->
                        if (postDelResp.isSuccess) {
                            //更新adapter
                            remove(adapterPosition)
                            ToastUtil.showShort(mContext.getString(R.string.topic_item_del_success))

                            //通知论坛模块刷新（切换当前小区和周边帖子）
                            val eventAddForum = EventAddForum()
                            eventAddForum.isUpdate = true
                            RxBus.getInstance().post(eventAddForum)

                            //通知ReplyListFragment 进行刷新
                            RxBus.getInstance().post(ReplyListFragment.notifyRefreshList)
                        } else {
                            ToastUtil.showShort(mContext.getString(R.string.topic_item_del_fail))
                        }
                    }, {})
        }

        //分享参数
        private fun getQueryId(data: ForumListNewBean): String {
            return "&postId=" + data.postId + "&nickName=" + data.nickName + "&content=" + data.content +
                    "&postTime=" + data.createTime + "&userId=" + data.userId + "&communityName=" + data.communityName
        }

    }


}