package cn.lejiayuan.Redesign.Function.topic.adapter

import android.content.Intent
import android.support.v4.app.FragmentManager
import android.text.Html
import android.text.Spannable
import android.text.SpannableString
import android.text.TextUtils
import android.text.style.AbsoluteSizeSpan
import android.text.style.ForegroundColorSpan
import android.view.View
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Function.topic.CommentFragment
import cn.lejiayuan.Redesign.Function.topic.PostCommentListActivity
import cn.lejiayuan.Redesign.Function.topic.model.PostListModel
import cn.lejiayuan.Redesign.Function.topic.model.ReplyMeCurrentComment
import cn.lejiayuan.Redesign.Function.topic.model.ReplyMeData
import cn.lejiayuan.Redesign.Function.topic.model.ReplyMeModel
import cn.lejiayuan.Redesign.Function.topic.model.req.ReplyReqModel
import cn.lejiayuan.activity.forum.ForumDetailActivity
import cn.lejiayuan.activity.news.NewsTabDetailActivity
import cn.lejiayuan.activity.news.NewsTabFragment
import cn.lejiayuan.bean.forum.CommentReplyBean
import cn.lejiayuan.bean.forum.responseBean.ForumCommentListBean
import cn.lejiayuan.bean.forum.responseBean.ForumListNewBean
import cn.lejiayuan.common.utils.ConstantUtils
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import cn.lejiayuan.fragment.forum.ForumCommentFragment
import cn.lejiayuan.view.forum.RadiusBackgroundSpan
import com.beijing.ljy.frame.util.MathUtil
import com.beijing.ljy.frame.util.TimeUtil
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.netease.youliao.newsfeeds.model.NNFChannelInfo
import com.netease.youliao.newsfeeds.model.NNFNewsInfo
import kotlinx.android.synthetic.main.item_ijoined_replied_layout.view.*

/**
 * Created by liushuo on 18/3/16.
 */
class IRepliedFragmentAdapter : BaseQuickAdapter<ReplyMeData, IRepliedFragmentAdapter.ViewHolder> {

    var supportFragmentManager: FragmentManager? = null

    constructor(layoutResId: Int) : super(layoutResId)

    constructor() : this(R.layout.item_ijoined_replied_layout)

    override fun convert(helper: IRepliedFragmentAdapter.ViewHolder, item: ReplyMeData) {
        helper.bindData(item, supportFragmentManager)
    }

    class ViewHolder(itemView: View) : BaseViewHolder(itemView) {
        fun bindData(data: ReplyMeData, supportFragmentManager: FragmentManager?) {
            with(data) {
                if (data.currentComment.commentUserHeadUrl.contains("https://wx.qlogo.cn/")) {
                    itemView.ijoined_sdvTopicMainItemHead.setImageURI(data.currentComment.commentUserHeadUrl)
                } else {
                    itemView.ijoined_sdvTopicMainItemHead.setImageURI("${data.currentComment.commentUserHeadUrl}@108h_108w_1e_1c")
                }

                itemView.ijoined_tvName.text = data.currentComment.commentUserNickName
                itemView.ijoined_tvDate.text = TimeUtil.getTimeString(data.currentComment.createTime.toLong())

                itemView.ijoined_tvReplyContent.text = if (data.currentComment.beReplyId.isEmpty()) data.currentComment.commentContent
                else "回复 ${data.currentComment.beReplyUserNickName}: ${data.currentComment.commentContent}"

                itemView.ijoined_tvReplyReplyContent.visibility = if (data.beReplyComment?.beReplyUserId.isNullOrEmpty()) View.GONE else View.VISIBLE

                itemView.ijoined_rlTopicLayout.setBackgroundColor(if (itemView.ijoined_tvReplyReplyContent.visibility == View.GONE) itemView.ijoined_rlTopicLayout.context.resources.getColor(R.color.grayBg) else
                    itemView.ijoined_rlTopicLayout.context.resources.getColor(R.color.white))
                itemView.ijoined_tvReplyReplyContent.text = if (data.beReplyComment?.beReplyUserId.isNullOrEmpty()) "${data.currentComment.beReplyUserNickName}: ${data.beReplyComment?.commentContent}"
                else "${data.currentComment.beReplyUserNickName} 回复 ${data.beReplyComment?.beReplyUserNickName}: ${data.beReplyComment?.commentContent}"


                //显示多少个 金豆
                if (data.currentComment!=null && !TextUtils.isEmpty(data.currentComment.gainBeanNum)
                        && !"0".equals(data.currentComment.gainBeanNum)){
                    showGainBeanNum(data.currentComment)
                }else{
                    itemView.tv_replay_jindou.visibility = View.GONE
                    itemView.view_line_jindou.visibility = View.GONE
                }


                itemView.ijoined_sdvTopicImage.visibility = View.GONE

                //帖子
                val title = "#${data.postItem.title}#"
                val content = "${data.postItem.content}"
                val spannableString = SpannableString(title + content)
                //设置颜色
                spannableString.setSpan(ForegroundColorSpan(itemView.context.getResources().getColor(R.color.ijoined_replay_color)),
                        0, title.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)

                itemView.ijoined_tvTopicUserName.text = data.postItem.userNickName
                //itemView.ijoined_tvTopicContent.text = "#${data.postItem.title}#${data.postItem.content}"
                itemView.ijoined_tvTopicContent.setText(spannableString)


                itemView.ijoined_tvReply.setOnClickListener {
                    var beCommentId = ""
                    if (data.currentComment.beCommentId.isEmpty()){
                        beCommentId = data.currentComment.commentId
                    }else{
                        beCommentId = data.currentComment.beCommentId;
                    }
                    ForumCommentFragment.newInstance(CommentReplyBean(data.currentComment.postId,
                            data.postItem.postType,
                            "",
                            beCommentId, //beCommentId
                            data.currentComment.commentId, //beReplyId
                            data.currentComment.commentUserId,  //beReplyUserId
                            data.currentComment.commentUserType), //beReplyUserType
                            "REPLY", data.currentComment.commentUserNickName) //beReplyUserNickName
                            .show(supportFragmentManager, "KinshipPicker")

                }


                itemView.setOnClickListener({

//                    val postModel = PostListModel()
//                    postModel.pageList = data.picInfoList
//                    postModel.title = data.activityTitle
//                    postModel.content = data.postContent
//                    postModel.postTime = data.postTime
//                    postModel.iconUrl = data.postUserIconUrl ?: ""
//                    postModel.nickName = data.postUserNickName
//                    postModel.postId = data.postId
//                    postModel.userId = data.postUserId
//
//                    postModel.isDoLikes = data.isDoLikes ?: "NO"
//                    postModel.likesNumber = data.postLikesNumber ?: "0"
//                    postModel.commentNumber = data.postCommentNumber ?: ""
//
//                    val intent = Intent(itemView.context, PostCommentListActivity::class.java)
//                    intent.putExtra(PostCommentListActivity.POST_INFO, postModel)
//                    itemView.context.startActivity(intent)

                    if (ConstantUtils.COMMENT_POST_TYPE_NEWS.equals(postItem.postType)){
                        NewsTabDetailActivity.tempNewsInfo = NNFNewsInfo()
                        NewsTabDetailActivity.tempNewsInfo.infoId = data.postItem.postId;
                        NewsTabDetailActivity.tempNewsInfo.infoType = NewsTabFragment.NewsInfoTypeClazz.ARTICLE
                        NewsTabDetailActivity.tempNewsInfo.producer = "recommendation"

                        NewsTabDetailActivity.tempChannelInfo = NNFChannelInfo()
                        NewsTabDetailActivity.tempChannelInfo.channelName =
                                itemView.context.resources.getString(R.string.new_tab_detail_12)

                        val intent = Intent(itemView.context, NewsTabDetailActivity::class.java)
                        itemView.context.startActivity(intent)

                    }else{
                        val newbean = ForumListNewBean()
                        newbean.setLocalFromType(ConstantUtils.LocalFromType.TOPIC_REPLAY_ME)
                        val intent = Intent(itemView.context, ForumDetailActivity::class.java)
                        intent.putExtra(ForumDetailActivity.POST_ID, data.postItem.postId)
                        intent.putExtra(ForumDetailActivity.USER_ID, data.postItem.userId)
//                            intent.putExtra(POST_INFO, postListModel);
                        intent.putExtra(ForumDetailActivity.POST_INFO, newbean)
                        itemView.context.startActivity(intent)
                    }
                })
            }
        }

        private fun showGainBeanNum(data: ReplyMeCurrentComment) {
            itemView.tv_replay_jindou.context;
            itemView.tv_replay_jindou.visibility = View.VISIBLE
            itemView.view_line_jindou.visibility = View.VISIBLE
            val builder = StringBuilder()
            val str = builder.append(data.commentUserNickName)
                    .append(" ")
                    .append(itemView.tv_replay_jindou.context.getString(R.string.forum_detail_05))
                    .append(" ")
                    .append("<font color='#29C985'>")
                    .append("+")
                    .append(data.gainBeanNum)
                    .append("</font>")
                    .append(" ")
                    .append(itemView.tv_replay_jindou.context.getString(R.string.forum_detail_04))
                    .toString()
            itemView.tv_replay_jindou.text = Html.fromHtml(str)
        }
    }
}