package cn.lejiayuan.Redesign.Function.topic.adapter

import android.content.Context
import android.content.Intent
import android.graphics.drawable.Drawable
import android.text.Html
import android.text.TextUtils
import android.view.View
import android.view.animation.Animation
import android.view.animation.AnimationUtils
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Function.topic.ImageGalleryActivity
import cn.lejiayuan.Redesign.Function.topic.PostCommentListActivity
import cn.lejiayuan.Redesign.Function.topic.PostListActivity
import cn.lejiayuan.Redesign.Function.topic.ReplyListFragment
import cn.lejiayuan.Redesign.Function.topic.model.PostListModel
import cn.lejiayuan.Redesign.Function.topic.model.req.LikeReqModel
import cn.lejiayuan.Redesign.Function.topic.model.req.TopicDELReqModel
import cn.lejiayuan.Redesign.Http.Common.HttpRspCd
import cn.lejiayuan.rxbus.RxBus
import cn.lejiayuan.Redesign.View.AnimationDialog
import cn.lejiayuan.Redesign.View.BaseDialogFactory
import cn.lejiayuan.Redesign.retrofit.ApiInterface
import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxRequestStatus
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import cn.lejiayuan.constance.Constance
import cn.lejiayuan.common.utils.Share
import cn.lejiayuan.common.utils.ToastUtil
import com.beijing.ljy.frame.util.MathUtil
import com.beijing.ljy.frame.util.TimeUtil
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.jakewharton.rxbinding2.view.RxView
import io.reactivex.android.schedulers.AndroidSchedulers
import kotlinx.android.synthetic.main.item_topic_main_layout.view.*
import kotlinx.android.synthetic.main.view_topic_item_bottom.view.*
import java.util.concurrent.TimeUnit

/**
 * 我发布的帖子Adapter
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/22
 * Time: 下午2:50
 */

class MyPostAdapter : BaseQuickAdapter<PostListModel, MyPostAdapter.ViewHolder> {

    private var cancleAnimationDialog: AnimationDialog? = null
    //默认不显示删除按钮
    private var isShowDelButton: Boolean = false

    constructor(layoutResId: Int) : super(layoutResId)

    constructor() : this(R.layout.item_topic_main_layout)

    override fun convert(helper: ViewHolder, item: PostListModel) {
        helper.bindData(item)
    }

    public fun setShowDelButton(bol : Boolean){
        isShowDelButton = bol;
    }

    inner class ViewHolder(itemView: View) : BaseViewHolder(itemView) {
        var context: Context? = null
        var likeAnim: Animation? = null

        var likeDrawable: Drawable? = null
        var unLikeDrawable: Drawable? = null

        var commentDrawable: Drawable? = null
        var shareDrawable: Drawable? = null
        var delDrawable: Drawable? = null

        init {
            context = itemView.context
            likeDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_zan_orange)
            likeDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))
            unLikeDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_zan_gray)
            unLikeDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            commentDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_pinglun)
            commentDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            shareDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_fenxiang)
            shareDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            delDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_del)
            delDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            likeAnim = AnimationUtils.loadAnimation(context, R.anim.like_anim)
        }

        fun bindData(topic: PostListModel) {
            with(topic) {

                itemView.sdvTopicMainItemHead.visibility = View.VISIBLE //View.INVISIBLE
                itemView.tvName.visibility = View.VISIBLE //View.GONE
                itemView.tvAddress.visibility = View.VISIBLE //View.GONE


                try {//null出现过闪退

                    val iconUrl = if (topic.iconUrl!= null) topic.iconUrl else ""
                    if (iconUrl.contains("https://wx.qlogo.cn/")){
                        itemView.sdvTopicMainItemHead.setImageURI(topic.iconUrl)
                    }else{
                        itemView.sdvTopicMainItemHead.setImageURI("${topic.iconUrl}@108h_108w_1e_1c")
                    }

                    val nickName = if (topic.nickName!= null) topic.nickName else ""
                    itemView.tvName.text = nickName
                } finally {

                }

//                if (topic.iconUrl.contains("https://wx.qlogo.cn/")){
//                    itemView.sdvTopicMainItemHead.setImageURI(topic.iconUrl)
//                }else{
//                    itemView.sdvTopicMainItemHead.setImageURI("${topic.iconUrl}@108h_108w_1e_1c")
//                }
//                itemView.tvName.text = topic.nickName

                itemView.tvAddress.text = topic.communityName

                itemView.tvDate.text = TimeUtil.getTimeString(topic.postTime.toLong())
                //itemView.tvTopic.text = "#${topic.title}#"
                //itemView.tvTopic.visibility = View.VISIBLE
                //itemView.tvTopicContent.text = topic.content

                itemView.tvTopicContent.text =
                        Html.fromHtml("<font color='#547392'>#${topic?.title}#</font><font color='#595959'>${topic.content}</font>")


                itemView.expandable_text.setOnClickListener {
                    //itemView.performClick()
                    //跳转到话题详情页面
                    val intent = Intent(itemView.context, PostListActivity::class.java)
                    intent.putExtra(PostListActivity.StaticValue.TOPIC_EVENTID.name, topic.activityId)
                    itemView.context.startActivity(intent)

                }

                if (topic.pageList != null && topic.pageList!!.isNotEmpty())
                    itemView.gvlTopicImages.setList(topic.pageList)
                itemView.gvlTopicImages.visibility = if (topic.pageList != null && topic.pageList!!.isNotEmpty()) View.VISIBLE else View.GONE
                itemView.gvlTopicImages.setOnItemClickListener { _, position ->
                    run {
                        val intent = Intent(itemView.context, ImageGalleryActivity::class.java)
                        intent.putExtra(ImageGalleryActivity.IMAGE_GALLERY_INDEX, position)
                        intent.putParcelableArrayListExtra(ImageGalleryActivity.IMAGE_GALLERY_IMAGES_INFO, topic.pageList as ArrayList)
                        itemView.context.startActivity(intent)
                    }
                }

                itemView.tvLikeBtn.text = topic.likesNumber
                itemView.tvLikeBtn.setCompoundDrawables(if ("No".equals(topic.isDoLikes)) unLikeDrawable else likeDrawable, null, null, null)

                itemView.tvCommentBtn.text = if (TextUtils.isEmpty(topic.commentNumber) || topic.commentNumber == "0") "评论" else topic.commentNumber
                itemView.tvComments.setCompoundDrawables(commentDrawable, null, null, null)

                itemView.tvShareBtn.setCompoundDrawables(shareDrawable, null, null, null)
                itemView.tvDelBtn.setCompoundDrawables(delDrawable, null, null, null)
                itemView.flayout_del.setVisibility(if(isShowDelButton) View.VISIBLE else View.GONE)


                itemView.setOnClickListener {
                    val intent = Intent(itemView.context, PostCommentListActivity::class.java)
                    intent.putExtra(PostCommentListActivity.POST_FROM, PostCommentListActivity.FromType.ME.name)
                    intent.putExtra(PostCommentListActivity.POST_INDEX, adapterPosition)
                    intent.putExtra(PostCommentListActivity.POST_INFO, topic)
                    itemView.context.startActivity(intent)
                }

//                RxView.clicks(itemView.tvLikeBtn)//点赞的点击事件
//                        .debounce(500, TimeUnit.MILLISECONDS) //防止抖动点击 500毫秒内 只能点击一次
//                        .observeOn(AndroidSchedulers.mainThread()) // 点击放在主线程执行
//                        .filter {
//                            //过滤器 先执行点击动画 然后判断是否要进行网络请求。
//                            itemView.tvLikeBtn.startAnimation(likeAnim)
//                            //itemView.tvLikeBtn.isEnabled
//                            true
//                        }
//                        .map {
//                            //初始化请求参数
//                            LikeReqModel(topic.postId, SharedPreferencesUtil
//                                    .getInstance(context).getuserId().toString())
//                        }
//                        .flatMap { reqModel ->
//                            if("Yes".equals(topic.isDoLikes)){
//                                //取消点赞
//                                BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//                                        .mUnDoLike(reqModel, RequestUtil.getHeader(reqModel))
//                                        .compose(RxSchedulersHelper.io_main()).toObservable()
//                            }else{
//                                //执行点赞请求
//                                BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//                                        .mDoLike(reqModel, RequestUtil.getHeader(reqModel))
//                                        .compose(RxSchedulersHelper.io_main()).toObservable()
//                            }
//                        }
//                        .filter { req ->
//                            //请求过滤 成功与否都输出请求结果 如果请求失败不继续执行
//                            //ToastUtil.showShort(req.rspInf)
//                            HttpRspCd.SUCCESS == req.rspCd
//                        }
//                        .subscribe({ req ->
//                            //点赞请求成功 更新点赞个数 设置按钮状态 更新adapter数据
//                            itemView.tvLikeBtn.text = req.likesNumber
//                            if("Yes".equals(topic.isDoLikes)){
//                                //取消点赞
//                                topic.isDoLikes = "No"
//                                itemView.tvLikeBtn.setCompoundDrawables(unLikeDrawable, null, null, null)
//                            }else{
//                                //执行点赞
//                                itemView.tvLikeBtn.setCompoundDrawables(likeDrawable, null, null, null)
//                                topic.isDoLikes = "Yes"
//                            }
//                            topic.likesNumber = req.likesNumber
//                            data[adapterPosition - headerLayoutCount] = topic
//                            notifyItemChanged(adapterPosition)
//                        }, { error ->
//                            ToastUtil.showShort(error.message)
//                        })

                RxView.clicks(itemView.tvShareBtn)
                        .debounce(500, TimeUnit.MILLISECONDS)
                        .observeOn(AndroidSchedulers.mainThread())
                        .subscribe({
                            var imageUrl = ""
                            if (topic.pageList != null && topic.pageList!!.isNotEmpty())
                                imageUrl = topic.pageList!![0].picUrl

                            Share.getShare(context).createSharedialog("${SharedPreferencesUtil.getInstance(context).getname()}发现个热闹事，还不来围观下。", "#${topic.title}#",
                                    if (imageUrl != "") imageUrl else "", null,
                                    R.mipmap.icon, "${Constance.URL_GET_POST_INFO_SHARE}postId=${topic.postId}")

                        }, {})


                itemView.tvDelBtn.setOnClickListener {
                    //弹出dialog
                    val result : Boolean?= false
                    val title = context!!.resources.getString(R.string.topic_item_dialog_title)
                    val content = context!!.resources.getString(R.string.topic_item_dialog_content)
                    val left = context!!.resources.getString(R.string.topic_item_dialog_left)
                    val right = context!!.resources.getString(R.string.topic_item_dialog_right)
                    val dialogFactory = BaseDialogFactory.getInstance() as BaseDialogFactory
                    cancleAnimationDialog = dialogFactory.createLayout(context,R.layout.dialog_topic_del)
                            .createIDS(R.id.simple_sure_title_txt, R.id.simple_sure_cancle_txt,
                                    R.id.simple_sure_sure_txt)
                            .setText(title,left,right)
                            .setContentText(content, R.id.simple_dialog_sure_content_txt)
                            .buildDialog { view, parames ->
                                cancleAnimationDialog!!.dismiss()
                                if (parames[0] as Int == 1) {
                                    httpReqTopicDel(topic)
                                }
                            }
                    cancleAnimationDialog!!.showDialog()
                }

            }
        }

        private fun httpReqTopicDel(topic: PostListModel) {
            //初始请求参数
            val req = TopicDELReqModel(topic.postId)
//            BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//                .mDelTopic(req, RequestUtil.getHeader(req))
//                    .compose(RxSchedulersHelper.io_main())
//                    .compose(RxRequestStatus.checkStatus())
//                    .map { result ->
//                        result.rspCd
//                    }
//                    .subscribe({ amount ->
//                        if (amount.equals("00000")) {
//                            //更新adapter
//                            remove(adapterPosition)
//                            ToastUtil.showShort(mContext.getString(R.string.topic_item_del_success))
//                            //通知ReplyListFragment 进行刷新
//                            RxBus.getInstance().post(ReplyListFragment.notifyRefreshList)
//                        } else {
//                            ToastUtil.showShort(mContext.getString(R.string.topic_item_del_fail))
//                        }
//                    }, {})
        }
    }
}
