package cn.lejiayuan.Redesign.Function.topic.adapter

import android.content.ClipData
import android.content.ClipboardManager
import android.content.Context
import android.content.Intent
import android.support.v4.app.FragmentManager
import android.text.TextUtils
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import android.widget.TextView
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Function.OldClass.login.LoginActivity
import cn.lejiayuan.Redesign.Function.topic.CommentFragment
import cn.lejiayuan.Redesign.Function.topic.ImageGalleryActivity
import cn.lejiayuan.Redesign.Function.topic.model.PostCommentAdapterModel
import cn.lejiayuan.Redesign.Function.topic.model.PostListModel
import cn.lejiayuan.Redesign.Function.topic.model.SecondaryCommentListModel
import cn.lejiayuan.Redesign.Function.topic.model.TopicCommentListModel
import cn.lejiayuan.Redesign.Function.topic.model.req.ReplyReqModel

import cn.lejiayuan.common.utils.SharedPreferencesUtil
import cn.lejiayuan.common.utils.ToastUtil
import com.beijing.ljy.frame.util.MathUtil
import com.beijing.ljy.frame.util.TextUtil
import com.beijing.ljy.frame.util.TimeUtil
import com.chad.library.adapter.base.BaseSectionQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import kotlinx.android.synthetic.main.item_topic_comment_layout.view.*
import kotlinx.android.synthetic.main.item_topic_main_layout.view.*

/**
 * 帖子评论列表Adapter
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/18
 * Time: 下午2:35
 */
class PostCommentAdapter : BaseSectionQuickAdapter<PostCommentAdapterModel, BaseViewHolder> {
    override fun convertHead(helper: BaseViewHolder?, item: PostCommentAdapterModel?) {
        helper as HeaderViewHolder
        helper.bindData(this.mTopicModel!!)
    }

    override fun convert(helper: BaseViewHolder, item: PostCommentAdapterModel?) {
        helper as ViewHolder
        helper.bindData(item?.t!!, supportFragmentManager)
    }

    override fun onCreateDefViewHolder(parent: ViewGroup, viewType: Int): BaseViewHolder =
            if (viewType == SECTION_HEADER_VIEW) HeaderViewHolder(getItemView(mSectionHeadResId, parent))
            else ViewHolder(getItemView(R.layout.item_topic_comment_layout, parent))


    var mTopicModel: PostListModel? = null
    var supportFragmentManager: FragmentManager? = null

    constructor(layoutResId: Int, sectionHeadResId: Int, data: MutableList<PostCommentAdapterModel>?)
            : super(layoutResId, sectionHeadResId, data)

    constructor() : this(R.layout.item_topic_comment_layout, R.layout.item_topic_main_layout, null)

    inner class ViewHolder(itemView: View) : BaseViewHolder(itemView) {
        var context: Context? = null

        init {
            context = itemView.context
        }

        fun bindData(data: TopicCommentListModel, supportFragmentManager: FragmentManager?) {
            with(data) {
                if (data.commentUserIconUrl.contains("https://wx.qlogo.cn/")){
                    itemView.sdvTopicCommentItemHead.setImageURI(data.commentUserIconUrl)
                }else{
                    itemView.sdvTopicCommentItemHead.setImageURI("${data.commentUserIconUrl}@108h_108w_1e_1c")
                }
                itemView.tvTopicCommentItemName.text = TextUtil.setText(data.commentUserNickName)
                itemView.tvTopicCommentItemTime.text = TimeUtil.getTimeString(data.createSmp.toLong())
                itemView.tvTopicCommentItemRecall.setOnClickListener {
                    if (!TextUtils.isEmpty(SharedPreferencesUtil.getInstance(context).token)) {
                        CommentFragment
                                .newInstance(ReplyReqModel(data.commentUserId, "reply",
                                        data.postId, data.commentId, data.commentId
                                        , SharedPreferencesUtil.getInstance(context).getuserId().toString())
                                        , CommentFragment.FromType.POST_DETAIL_REPLY.name
                                        , adapterPosition
                                        , data.commentUserNickName)
                                .show(supportFragmentManager, "KinshipPicker")
                    } else {
                        context?.startActivity(Intent(context, LoginActivity::class.java))
                    }
                }

                itemView.tvTopicCommentItemComment.text = TextUtil.setText(data.commentContent)
                itemView.llTopicCommentItemReplyLayout.visibility = if (data.replyList == null) View.GONE
                else View.VISIBLE
                itemView.llTopicCommentItemReplyLayout.removeAllViews()
                data.replyList?.forEach { secondaryCommentListModel: SecondaryCommentListModel ->
                    run {
                        val replyView = TextView(itemView.context)
                        replyView.text = "${secondaryCommentListModel.commentUserNickName} ${if (secondaryCommentListModel.beReplyUserNickName.isEmpty()) ": "
                        else "回复" + secondaryCommentListModel.beReplyUserNickName + ": "}${secondaryCommentListModel.commentContent}"
                        replyView.textSize = 14f
                        replyView.setTextColor(itemView.context.resources.getColor(R.color.textColorTitle))
                        replyView.setLineSpacing(MathUtil.diptopx(context, 3f).toFloat(), 1f)
                        replyView.setOnClickListener {
                            if (!TextUtils.isEmpty(SharedPreferencesUtil.getInstance(context).token)) {
                                CommentFragment
                                        .newInstance(ReplyReqModel(secondaryCommentListModel.commentUserId, "reply",
                                                secondaryCommentListModel.postId, data.commentId, secondaryCommentListModel.commentId
                                                , SharedPreferencesUtil.getInstance(context).getuserId().toString())
                                                , CommentFragment.FromType.POST_DETAIL_REPLY_OTHER.name
                                                , adapterPosition
                                                , secondaryCommentListModel.commentUserNickName)
                                        .show(supportFragmentManager, "KinshipPicker")
                            } else {
                                context?.startActivity(Intent(context, LoginActivity::class.java))
                            }
                        }

                        val layoutParams = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT)
                        layoutParams.bottomMargin = MathUtil.diptopx(itemView.context, 8f)
                        itemView.llTopicCommentItemReplyLayout.addView(replyView, layoutParams)
                    }
                }
            }
        }
    }

    inner class HeaderViewHolder(view: View) : BaseViewHolder(view) {
        var context: Context? = null
        init {
            context = view.context
        }
        fun bindData(data: PostListModel) {
            with(data) {
                if (data.iconUrl.contains("https://wx.qlogo.cn/")){
                    itemView.sdvTopicMainItemHead.setImageURI(data.iconUrl)
                }else{
                    itemView.sdvTopicMainItemHead.setImageURI("${data.iconUrl}@108h_108w_1e_1c")
                }
                itemView.tvName.text = data.nickName
                itemView.tvAddress.text = data.communityName
                if (!TextUtils.isEmpty(data.postTime))
                    itemView.tvDate.text = TimeUtil.getTimeString(data.postTime.toLong())

                itemView.tvTopic.text = "#${mTopicModel?.title}#"
                itemView.tvTopic.visibility = View.VISIBLE
                itemView.tvTopicContent.text = data.content

//                itemView.tvTopicContent.text = Html.fromHtml("<font color='#547392'>#${mTopicModel?.title}#</font><font color='#595959'>${data.content}</font>")

                //长按复制
                itemView.expandable_text.setOnLongClickListener{
                    val mText = data.content
                    //获取剪贴板管理器：
                    var clipManager = (context!!.getSystemService(Context.CLIPBOARD_SERVICE)) as ClipboardManager
                    // 创建普通字符型ClipData
                    var mClipData = ClipData.newPlainText("Label", mText) as ClipData
                    // 将ClipData内容放到系统剪贴板里。
                    clipManager.setPrimaryClip(mClipData)
                    ToastUtil.showShort(context!!.resources.getString(R.string.topic_postcomment_05))
                    false
                }

                if (data.pageList != null && data.pageList!!.isNotEmpty())
                    itemView.gvlTopicImages.setList(data.pageList)
                itemView.gvlTopicImages.visibility = if (data.pageList != null && data.pageList!!.isNotEmpty()) View.VISIBLE else View.GONE
                itemView.gvlTopicImages.setOnItemClickListener { _, position ->
                    run {
                        val intent = Intent(itemView.context, ImageGalleryActivity::class.java)
                        intent.putExtra(ImageGalleryActivity.IMAGE_GALLERY_INDEX, position)
                        intent.putParcelableArrayListExtra(ImageGalleryActivity.IMAGE_GALLERY_IMAGES_INFO, data.pageList as ArrayList)
                        itemView.context.startActivity(intent)
                    }
                }
                itemView.llCommentLayout.visibility = View.VISIBLE
                itemView.llButtons.visibility = View.GONE
                itemView.tvComments.text = "评论 ${mTopicModel?.commentNumber}"
            }
        }
    }

}