package cn.lejiayuan.Redesign.Function.topic.adapter

import android.content.Context
import android.content.Intent
import android.graphics.drawable.Drawable
import android.support.annotation.LayoutRes
import android.text.Html
import android.text.TextUtils
import android.view.View
import android.view.animation.Animation
import android.view.animation.AnimationUtils
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Function.OldClass.login.LoginActivity
import cn.lejiayuan.Redesign.Function.topic.ImageGalleryActivity
import cn.lejiayuan.Redesign.Function.topic.PostCommentListActivity
import cn.lejiayuan.Redesign.Function.topic.PostListActivity
import cn.lejiayuan.Redesign.Function.topic.model.PostListModel
import cn.lejiayuan.Redesign.Function.topic.model.TopicListModel
import cn.lejiayuan.Redesign.Function.topic.model.req.LikeReqModel
import cn.lejiayuan.Redesign.Http.Common.HttpRspCd
import cn.lejiayuan.Redesign.retrofit.ApiInterface

import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.common.utils.ShareUtils
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import cn.lejiayuan.constance.Constance
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.jakewharton.rxbinding2.view.RxView
import io.reactivex.android.schedulers.AndroidSchedulers
import kotlinx.android.synthetic.main.item_topic_main_layout.view.*
import kotlinx.android.synthetic.main.view_topic_item_bottom.view.*
import java.util.concurrent.TimeUnit
import cn.lejiayuan.common.utils.ToastUtil
import com.beijing.ljy.frame.util.MathUtil
import com.beijing.ljy.frame.util.TimeUtil

/**
 * 帖子列表页Adapter
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/16
 * Time: 下午6:49
 */



class PostListAdapter : BaseQuickAdapter<PostListModel, PostListAdapter.ViewHolder> {
    override fun convert(helper: ViewHolder, item: PostListModel) {
        helper.bindData(item)
    }

    var topicInfo: TopicListModel? = null


    //构造方法
    constructor(@LayoutRes layoutResId: Int) : super(layoutResId)

    constructor() : this(R.layout.item_topic_main_layout)


    inner class ViewHolder(view: View) : BaseViewHolder(view) {

        var context: Context? = null
        var likeAnim: Animation? = null

        var likeDrawable: Drawable? = null
        var unLikeDrawable: Drawable? = null
        var commentDrawable: Drawable? = null
        var shareDrawable: Drawable? = null

        init {
            context = view.context

            likeDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_zan_orange)
            likeDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))
            unLikeDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_zan_gray)
            unLikeDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            commentDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_pinglun)
            commentDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            shareDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_fenxiang)
            shareDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            likeAnim = AnimationUtils.loadAnimation(context, R.anim.like_anim)
        }

        fun bindData(data: PostListModel) {
            with(data) {
                try {//null出现过闪退

                    val iconUrl = if (data.iconUrl!= null) data.iconUrl else ""
                    if (iconUrl.contains("https://wx.qlogo.cn/")){
                        itemView.sdvTopicMainItemHead.setImageURI(data.iconUrl)
                    }else{
                        itemView.sdvTopicMainItemHead.setImageURI("${data.iconUrl}@108h_108w_1e_1c")
                    }

                    val nickName = if (data.nickName!= null) data.nickName else ""
                    itemView.tvName.text = nickName
                } finally {

                }

                itemView.tvAddress.text = data.communityName
                itemView.tvDate.text = TimeUtil.getTimeString(data.postTime.toLong())

                //itemView.tvTopic.text = "#${topicInfo?.subject}#"
                //itemView.tvTopic.visibility = View.VISIBLE
                //itemView.tvTopicContent.text = data.content


                itemView.tvTopicContent.text =
                        Html.fromHtml("<font color='#547392'>#${topicInfo?.subject}#</font><font color='#595959'>${data.content}</font>")



                itemView.expandable_text.setOnClickListener {
                    itemView.performClick()
                }

                if (data.pageList != null && data.pageList!!.isNotEmpty())
                    itemView.gvlTopicImages.setList(data.pageList)
                itemView.gvlTopicImages.visibility = if (data.pageList != null && data.pageList!!.isNotEmpty()) View.VISIBLE else View.GONE
                itemView.gvlTopicImages.setOnItemClickListener { _, position ->
                    run {
                        val intent = Intent(itemView.context, ImageGalleryActivity::class.java)
                        intent.putExtra(ImageGalleryActivity.IMAGE_GALLERY_INDEX, position)
                        intent.putParcelableArrayListExtra(ImageGalleryActivity.IMAGE_GALLERY_IMAGES_INFO, data.pageList as ArrayList)
                        itemView.context.startActivity(intent)
                    }
                }
                itemView.tvLikeBtn.text = data.likesNumber
                itemView.tvLikeBtn.tag = data.isDoLikes
                itemView.tvLikeBtn.setCompoundDrawables(if (itemView.tvLikeBtn.tag.toString() != "Yes") unLikeDrawable else likeDrawable, null, null, null)

                itemView.tvCommentBtn.text = if (TextUtils.isEmpty(data.commentNumber) || data.commentNumber == "0") "评论" else data.commentNumber
                itemView.tvCommentBtn.setCompoundDrawables(commentDrawable, null, null, null)

                itemView.tvShareBtn.setCompoundDrawables(shareDrawable, null, null, null)
//                //点赞
//                RxView.clicks(itemView.tvLikeBtn)
//                        .debounce(500, TimeUnit.MILLISECONDS)
//                        .observeOn(AndroidSchedulers.mainThread())
//                        .filter {
//                            if (!TextUtils.isEmpty(SharedPreferencesUtil.getInstance(context).token)) true else {
//                                context?.startActivity(Intent(context, LoginActivity::class.java))
//                                false
//                            }
//                        }
//                        .filter {
//                            itemView.tvLikeBtn.startAnimation(likeAnim)
//                            //itemView.tvLikeBtn.tag != "Yes"
//                            true
//                        }
//                        .map {
//                            LikeReqModel(data.postId, SharedPreferencesUtil
//                                    .getInstance(context).getuserId().toString())
//                        }
//                        .flatMap { reqModel ->
//                            if("Yes".equals(data.isDoLikes)){
//                                //取消点赞
//                                BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//                                        .mUnDoLike(reqModel, RequestUtil.getHeader(reqModel))
//                                        .compose(RxSchedulersHelper.io_main()).toObservable()
//                            }else{
//                                //点赞
//                                BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//                                        .mDoLike(reqModel, RequestUtil.getHeader(reqModel))
//                                        .compose(RxSchedulersHelper.io_main()).toObservable()
//                            }
//                        }
//                        .filter { req ->
//                            //ToastUtil.showShort(req.rspInf)
//                            HttpRspCd.SUCCESS == req.rspCd
//                        }
//                        .subscribe({ req ->
//                            itemView.tvLikeBtn.text = req.likesNumber
//                            if("Yes".equals(data.isDoLikes)){
//                                //取消点赞
//                                itemView.tvLikeBtn.setCompoundDrawables(unLikeDrawable, null, null, null)
//                                data.isDoLikes = "No"
//                            }else{
//                                //点赞
//                                itemView.tvLikeBtn.setCompoundDrawables(likeDrawable, null, null, null)
//                                data.isDoLikes = "Yes"
//                            }
//                            data.likesNumber = req.likesNumber
//                            getData()[adapterPosition - headerLayoutCount] = data
//                            notifyItemChanged(adapterPosition)
//                        }, { error ->
//                            ToastUtil.showShort(error.message)
//                        })

                //评论
                RxView.clicks(itemView.tvCommentBtn)
                        .debounce(500, TimeUnit.MILLISECONDS)
                        .observeOn(AndroidSchedulers.mainThread())
                        .filter {
                            if (!TextUtils.isEmpty(SharedPreferencesUtil.getInstance(context).token)) true else {
                                context?.startActivity(Intent(context, LoginActivity::class.java))
                                false
                            }
                        }
                        .subscribe({ _ ->
                            val intent = Intent(itemView.context, PostCommentListActivity::class.java)
                            intent.putExtra(PostCommentListActivity.POST_INFO, data)
                            intent.putExtra(PostCommentListActivity.POST_FROM, PostListActivity.NOTIFY_COMMENT_NUMBER)
                            intent.putExtra(PostCommentListActivity.POST_INDEX, adapterPosition)
                            itemView.context.startActivity(intent)
                        }, {})

                //分享
                RxView.clicks(itemView.tvShareBtn)
                        .debounce(500, TimeUnit.MILLISECONDS)
                        .observeOn(AndroidSchedulers.mainThread())
                        .subscribe({
                            var imageUrl = ""
                            if (data.pageList != null && data.pageList!!.isNotEmpty())
                                imageUrl = data.pageList!![0].picUrl
                            ShareUtils.getShareUitls(context).startShare(Constance.SHARE_POST_DETAIL, getQueryId(data), true)
//                            Share.getShare(context).createSharedialog("我发现个热闹事，还不来围观下。", "#${topicInfo?.subject}#${topicInfo?.summary}",
//                                    if (imageUrl != "") imageUrl else "", null,
//                                    R.mipmap.icon, "${Constance.URL_GET_POST_INFO_SHARE}postId=${data.postId}")

                        }, {})

                itemView.setOnClickListener {
                    val intent = Intent(itemView.context, PostCommentListActivity::class.java)
                    intent.putExtra(PostCommentListActivity.POST_FROM, PostCommentListActivity.FromType.LIST.name)
                    intent.putExtra(PostCommentListActivity.POST_INDEX, adapterPosition)
                    intent.putExtra(PostCommentListActivity.POST_INFO, data)
                    itemView.context.startActivity(intent)
                }
            }
        }
    }
    private fun getQueryId(data: PostListModel): String {
        return "&postId=" + data?.postId + "&nickName=" + data?.nickName + "&content=" + data?.content +
                "&postTime=" + data?.postTime + "&userId=" + data?.userId + "&communityName=" + data?.communityName
    }
}

