package cn.lejiayuan.Redesign.Function.topic.adapter

import android.content.Intent
import android.support.v4.app.FragmentManager
import android.view.View
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Function.topic.CommentFragment
import cn.lejiayuan.Redesign.Function.topic.PostCommentListActivity
import cn.lejiayuan.Redesign.Function.topic.model.PostListModel
import cn.lejiayuan.Redesign.Function.topic.model.ReplyMeModel
import cn.lejiayuan.Redesign.Function.topic.model.req.ReplyReqModel
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import com.beijing.ljy.frame.util.TimeUtil
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import kotlinx.android.synthetic.main.item_topic_reply_layout.view.*

/**
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/22
 * Time: 下午5:40
 */
class PostReplyAdapter : BaseQuickAdapter<ReplyMeModel, PostReplyAdapter.ViewHolder> {

    var supportFragmentManager: FragmentManager? = null

    constructor(layoutResId: Int) : super(layoutResId)

    constructor() : this(R.layout.item_topic_reply_layout)

    override fun convert(helper: ViewHolder, item: ReplyMeModel) {
        helper.bindData(item, supportFragmentManager)
    }

    class ViewHolder(itemView: View) : BaseViewHolder(itemView) {
        fun bindData(data: ReplyMeModel, supportFragmentManager: FragmentManager?) {
            with(data) {
                if (data.commentUserIconUrl.contains("https://wx.qlogo.cn/")) {
                    itemView.sdvTopicMainItemHead.setImageURI(data.commentUserIconUrl)
                } else {
                    itemView.sdvTopicMainItemHead.setImageURI("${data.commentUserIconUrl}@108h_108w_1e_1c")
                }

                itemView.tvName.text = data.commentUserNickName
                itemView.tvDate.text = TimeUtil.getTimeString(data.createTime.toLong())

                itemView.tvReplyContent.text = if (data.beReplyUserId.isEmpty()) data.commentContent
                else "回复 ${data.beReplyUserNickName}: ${data.commentContent}"

                itemView.tvReplyReplyContent.visibility = if (data.upperReply?.beReplyUserId.isNullOrEmpty()) View.GONE else View.VISIBLE

                itemView.rlTopicLayout.setBackgroundColor(if (itemView.tvReplyReplyContent.visibility == View.GONE) itemView.rlTopicLayout.context.resources.getColor(R.color.grayBg) else
                    itemView.rlTopicLayout.context.resources.getColor(R.color.white))
                itemView.tvReplyReplyContent.text = if (data.upperReply?.beCommentId.isNullOrEmpty()) "${data.beReplyUserNickName}: ${data.upperReply?.commentContent}"
                else "${data.beReplyUserNickName} 回复 ${data.upperReply?.beReplyUserNickName}: ${data.upperReply?.commentContent}"

                itemView.sdvTopicImage.setImageURI(if (data.picInfoList != null && data.picInfoList!!.isNotEmpty()) data.picInfoList!![0].picUrl else "")
                itemView.sdvTopicImage.visibility = if (data.picInfoList == null) View.GONE else View.VISIBLE
                itemView.tvTopicUserName.text = data.postUserNickName
                itemView.tvTopicContent.text = "#${data.activityTitle}#${data.postContent}"


                itemView.tvReply.setOnClickListener {
                    CommentFragment
                            .newInstance(ReplyReqModel(data.commentUserId, "reply",
                                    data.postId, if (data.commentType == "comment") data.commentId else data.beCommentId, data.commentId
                                    , SharedPreferencesUtil.getInstance(itemView.context).getuserId().toString()), "", 0, data.beReplyUserNickName)
                            .show(supportFragmentManager, "KinshipPicker")
                }


                itemView.setOnClickListener({
                    val postModel = PostListModel()
                    postModel.pageList = data.picInfoList
                    postModel.title = data.activityTitle
                    postModel.content = data.postContent
                    postModel.postTime = data.postTime
                    postModel.iconUrl = data.postUserIconUrl ?: ""
                    postModel.nickName = data.postUserNickName
                    postModel.postId = data.postId
                    postModel.userId = data.postUserId

                    postModel.isDoLikes = data.isDoLikes ?: "No"
                    postModel.likesNumber = data.postLikesNumber ?: "0"
                    postModel.commentNumber = data.postCommentNumber ?: ""

                    val intent = Intent(itemView.context, PostCommentListActivity::class.java)
                    intent.putExtra(PostCommentListActivity.POST_INFO, postModel)
                    itemView.context.startActivity(intent)

                })


            }
        }
    }
}