package cn.lejiayuan.Redesign.Function.topic.adapter

import android.content.Intent
import android.support.annotation.LayoutRes
import android.view.View
import android.widget.LinearLayout
import android.widget.RelativeLayout
import butterknife.ButterKnife
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Function.topic.PostListActivity
import cn.lejiayuan.Redesign.Function.topic.model.TopicListModel
import cn.lejiayuan.common.Manager.WindowManager
import com.beijing.ljy.frame.util.TextUtil
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import kotlinx.android.synthetic.main.item_topic_layout.view.*

/**
 * 话题列表页Adapter
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/9/6
 * Time: 下午1:48
 */
class TopicListAdapter : BaseQuickAdapter<TopicListModel, TopicListAdapter.ViewHolder> {

    //构造方法
    constructor(@LayoutRes layoutResId: Int) : super(layoutResId)

    constructor() : this(R.layout.item_topic_layout)

    //绑定数据 此操作在ViewHolder中进行了 此处只需将数据传入ViewHolder中即可
    override fun convert(helper: TopicListAdapter.ViewHolder?, item: TopicListModel) {
        helper?.bindData(item)
    }

    /**
     * inner 代表内部类。内部类可以引用外部类变量
     */
    inner class ViewHolder(itemView: View) : BaseViewHolder(itemView) {

        init {
            ButterKnife.bind(this, itemView)

            val layout = itemView.sdvTopicImage.parent as RelativeLayout
            val params = layout.layoutParams as LinearLayout.LayoutParams
            params.height = (WindowManager.getWindowWidth(itemView.context) * 0.55).toInt()
            layout.layoutParams = params
            itemView.sdvTopicImage.setOnClickListener {
                val intent = Intent(itemView.context, PostListActivity::class.java)
                intent.putExtra(PostListActivity.StaticValue.TOPIC_FROM.name, PostListActivity.PostFrom.LIST.name)
                intent.putExtra(PostListActivity.StaticValue.TOPIC_INDEX.name, adapterPosition)
                intent.putExtra(PostListActivity.StaticValue.TOPIC_INFO.name, getItem(adapterPosition))
                itemView.context.startActivity(intent)
            }
        }

        fun bindData(data: TopicListModel) {
            itemView.sdvTopicImage.setImageURI(data.coverImgUrl)
            itemView.tvTopicTitle.text = "${TextUtil.setText(data.subject)}"
            itemView.tvTopicDesc.text = TextUtil.setText(data.summary)
            itemView.tvTopicRead.text = TextUtil.setText(data.readTotal)
        }
    }
}