package cn.lejiayuan.Redesign.Function.topic.adapter

import android.content.Context
import android.content.Intent
import android.graphics.drawable.Drawable
import android.text.TextUtils
import android.view.View
import android.view.animation.Animation
import android.view.animation.AnimationUtils
import cn.lejiayuan.R
import cn.lejiayuan.Redesign.Function.topic.PostCommentListActivity
import cn.lejiayuan.Redesign.Function.topic.model.PostListModel
import cn.lejiayuan.Redesign.Function.topic.model.req.LikeReqModel
import cn.lejiayuan.Redesign.Http.Common.HttpRspCd
import cn.lejiayuan.Redesign.retrofit.ApiInterface

import cn.lejiayuan.Redesign.retrofit.RequestUtil
import cn.lejiayuan.Redesign.retrofit.RxSchedulersHelper
import cn.lejiayuan.basebusinesslib.base.network.BaseNetEngine
import cn.lejiayuan.common.utils.SharedPreferencesUtil
import cn.lejiayuan.constance.Constance
import cn.lejiayuan.common.utils.Share
import cn.lejiayuan.common.utils.ToastUtil
import com.beijing.ljy.frame.util.MathUtil
import com.beijing.ljy.frame.util.TimeUtil
import com.beijing.ljy.frame.view.AnimationDialog
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.jakewharton.rxbinding2.view.RxView
import io.reactivex.android.schedulers.AndroidSchedulers
import kotlinx.android.synthetic.main.item_topic_main_layout.view.*
import kotlinx.android.synthetic.main.view_topic_item_bottom.view.*
import java.util.concurrent.TimeUnit

/**
 * Created by liushuo on 17/11/30.
 *
 * 凑热闹-->"最新"  adapter
 */
class TopicTableNewAdapter : BaseQuickAdapter<PostListModel, TopicTableNewAdapter.ViewHolder> {

    private var cancleAnimationDialog: AnimationDialog? = null

    constructor(layoutResId: Int) : super(layoutResId)

    constructor() : this(R.layout.item_topic_main_layout)

    override fun convert(helper: ViewHolder, item: PostListModel) {
        helper.bindData(item)
    }


    inner class ViewHolder(itemView: View) : BaseViewHolder(itemView) {
        var context: Context? = null
        var likeAnim: Animation? = null

        var likeDrawable: Drawable? = null
        var unLikeDrawable: Drawable? = null

        var commentDrawable: Drawable? = null
        var shareDrawable: Drawable? = null
        var delDrawable: Drawable? = null

        init {
            context = itemView.context
            likeDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_zan_orange)
            likeDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))
            unLikeDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_zan_gray)
            unLikeDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            commentDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_pinglun)
            commentDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            shareDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_fenxiang)
            shareDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            delDrawable = context?.resources?.getDrawable(R.mipmap.courenao_icon_del)
            delDrawable?.setBounds(0, 0, MathUtil.diptopx(context, 18f), MathUtil.diptopx(context, 18f))

            likeAnim = AnimationUtils.loadAnimation(context, R.anim.like_anim)
        }

        fun bindData(topic: PostListModel) {
            with(topic) {
                itemView.sdvTopicMainItemHead.visibility = View.INVISIBLE
                itemView.tvName.visibility = View.GONE
                itemView.tvAddress.visibility = View.GONE
                itemView.tvDate.text = TimeUtil.getTimeString(topic.postTime.toLong())
                itemView.tvTopic.text = "#${topic.title}#"
                itemView.tvTopic.visibility = View.VISIBLE
                itemView.tvTopicContent.text = topic.content

                itemView.expandable_text.setOnClickListener {
                    itemView.performClick()
                }

                if (topic.pageList != null && topic.pageList!!.isNotEmpty())
                    itemView.gvlTopicImages.setList(topic.pageList)
                itemView.gvlTopicImages.visibility = if (topic.pageList != null && topic.pageList!!.isNotEmpty()) View.VISIBLE else View.GONE

                itemView.tvLikeBtn.text = topic.likesNumber
                itemView.tvLikeBtn.isEnabled = topic.isDoLikes != "Yes"
                itemView.tvLikeBtn.setCompoundDrawables(if (itemView.tvLikeBtn.isEnabled) unLikeDrawable else likeDrawable, null, null, null)

                itemView.tvCommentBtn.text = if (TextUtils.isEmpty(topic.commentNumber) || topic.commentNumber == "0") "评论" else topic.commentNumber
                itemView.tvComments.setCompoundDrawables(commentDrawable, null, null, null)

                itemView.tvShareBtn.setCompoundDrawables(shareDrawable, null, null, null)
                itemView.tvDelBtn.setCompoundDrawables(delDrawable, null, null, null)

                itemView.setOnClickListener {
                    val intent = Intent(itemView.context, PostCommentListActivity::class.java)
                    intent.putExtra(PostCommentListActivity.POST_FROM, PostCommentListActivity.FromType.ME.name)
                    intent.putExtra(PostCommentListActivity.POST_INDEX, adapterPosition)
                    intent.putExtra(PostCommentListActivity.POST_INFO, topic)
                    itemView.context.startActivity(intent)
                }

//                RxView.clicks(itemView.tvLikeBtn)//点赞的点击事件
//                        .debounce(500, TimeUnit.MILLISECONDS) //防止抖动点击 500毫秒内 只能点击一次
//                        .observeOn(AndroidSchedulers.mainThread()) // 点击放在主线程执行
//                        .filter {
//                            //过滤器 先执行点击动画 然后判断是否要进行网络请求。
//                            itemView.tvLikeBtn.startAnimation(likeAnim)
//                            itemView.tvLikeBtn.isEnabled
//                        }
//                        .map {
//                            //初始化请求参数
//                            LikeReqModel(topic.postId, SharedPreferencesUtil
//                                    .getInstance(context).getuserId().toString())
//                        }
//                        .flatMap { reqModel ->
//                            //执行点赞请求
//                            BaseNetEngine.getInstance().getsApiService(ApiInterface::class.java)
//                                    .mDoLike(reqModel, RequestUtil.getHeader(reqModel))
//                                    .compose(RxSchedulersHelper.io_main()).toObservable()
//                        }
//                        .filter { req ->
//                            //请求过滤 成功与否都输出请求结果 如果请求失败不继续执行
//                            ToastUtil.showShort(req.rspInf)
//                            HttpRspCd.SUCCESS == req.rspCd
//                        }
//                        .subscribe({ req ->
//                            //点赞请求成功 更新点赞个数 设置按钮状态 更新adapter数据
//                            itemView.tvLikeBtn.text = req.likesNumber
//                            itemView.tvLikeBtn.isEnabled = false
//                            itemView.tvLikeBtn.setCompoundDrawables(if (itemView.tvLikeBtn.isEnabled) unLikeDrawable else likeDrawable, null, null, null)
//                            topic.isDoLikes = "Yes"
//                            topic.likesNumber = req.likesNumber
//
//                            data[adapterPosition - headerLayoutCount] = topic
//                            notifyItemChanged(adapterPosition)
//                        }, { error ->
//                            ToastUtil.showShort(error.message)
//                        })

                RxView.clicks(itemView.tvShareBtn)
                        .debounce(500, TimeUnit.MILLISECONDS)
                        .observeOn(AndroidSchedulers.mainThread())
                        .subscribe({
                            var imageUrl = ""
                            if (topic.pageList != null && topic.pageList!!.isNotEmpty())
                                imageUrl = topic.pageList!![0].picUrl

                            Share.getShare(context).createSharedialog("${SharedPreferencesUtil.getInstance(context).getname()}发现个热闹事，还不来围观下。", "#${topic.title}#",
                                    if (imageUrl != "") imageUrl else "", null,
                                    R.mipmap.icon, "${Constance.URL_GET_POST_INFO_SHARE}postId=${topic.postId}")

                        }, {})



            }
        }
    }
}
