package cn.lejiayuan.Redesign.Function.topic.model

import android.os.Parcel
import android.os.Parcelable

import cn.lejiayuan.bean.PhotoInfo

/**
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/9/4
 * Time: 上午10:45
 */

class PostListModel() : Parcelable {

    var content: String = ""
    var commentNumber: String = ""
    var isDoLikes: String = "No"
    var title: String = ""
    var postType: String = ""
    var readNumber: String = "0"
    var nickName: String = ""
    var iconUrl: String = ""
    var activityId: String = ""
    var likesNumber: String = "0"
    var postTime: String = ""
    var userId: String = ""
    var communityId: String = ""
    var postId: String = ""
    var communityName: String = ""
    var pageList: List<PhotoInfo>? = null

    constructor(parcel: Parcel) : this() {
        content = parcel.readString()
        commentNumber = parcel.readString()
        isDoLikes = parcel.readString()
        title = parcel.readString()
        postType = parcel.readString()
        readNumber = parcel.readString()
        nickName = parcel.readString()
        iconUrl = parcel.readString() ?: ""
        activityId = parcel.readString()
        likesNumber = parcel.readString()
        postTime = parcel.readString()
        userId = parcel.readString()
        communityId = parcel.readString()
        postId = parcel.readString()
        communityName = parcel.readString()
        pageList = parcel.createTypedArrayList(PhotoInfo.CREATOR)
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(content)
        parcel.writeString(commentNumber)
        parcel.writeString(isDoLikes)
        parcel.writeString(title)
        parcel.writeString(postType)
        parcel.writeString(readNumber)
        parcel.writeString(nickName)
        parcel.writeString(iconUrl)
        parcel.writeString(activityId)
        parcel.writeString(likesNumber)
        parcel.writeString(postTime)
        parcel.writeString(userId)
        parcel.writeString(communityId)
        parcel.writeString(postId)
        parcel.writeString(communityName)
        parcel.writeTypedList(pageList)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<PostListModel> {
        override fun createFromParcel(parcel: Parcel): PostListModel {
            return PostListModel(parcel)
        }

        override fun newArray(size: Int): Array<PostListModel?> {
            return arrayOfNulls(size)
        }
    }


}
