package cn.lejiayuan.Redesign.Function.topic.model

import android.os.Parcel
import android.os.Parcelable
import cn.lejiayuan.bean.PhotoInfo
import java.io.Serializable
import java.util.ArrayList

/**
 * User: Axl_Jacobs(Axl.Jacobs@gmail.com)
 * Date: 2017/8/14
 * Time: 下午2:42
 */

class TopicDetailListModel : Parcelable {
    var headerUrl: String? = ""
    var name: String? = ""
    var address: String? = ""
    var date: String? = ""
    var content: String? = ""
    var images: List<PhotoInfo> = ArrayList()
    var like: String? = ""

    constructor(parcel: Parcel) : this() {
        headerUrl = parcel.readString()
        name = parcel.readString()
        address = parcel.readString()
        date = parcel.readString()
        content = parcel.readString()
        images = parcel.createTypedArrayList(PhotoInfo.CREATOR)
        like = parcel.readString()
    }

    constructor()

    constructor(headerUrl: String, name: String, address: String, date: String, content: String, images: List<PhotoInfo>, like: String) {
        this.headerUrl = headerUrl
        this.name = name
        this.address = address
        this.date = date
        this.content = content
        this.images = images
        this.like = like
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(headerUrl)
        parcel.writeString(name)
        parcel.writeString(address)
        parcel.writeString(date)
        parcel.writeString(content)
        parcel.writeTypedList(images)
        parcel.writeString(like)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<TopicDetailListModel> {
        override fun createFromParcel(parcel: Parcel): TopicDetailListModel {
            return TopicDetailListModel(parcel)
        }

        override fun newArray(size: Int): Array<TopicDetailListModel?> {
            return arrayOfNulls(size)
        }
    }


}